/*        REFORMED VECTORIZER
	  Pixel Image to Link/Arc Image.
This program is written from 1995MAY22 by T.Suzuki
  at OGOSE_OGOSE 810 SAITAMA JAPAN.
This is a reformed vectorizer.
This is through area division, operates 2vectors cross.
TelFax 0492_92_6284

EDEP is environment dependant.
geo,Geo,GEO are not used in program_codes. whithout "lg".
AreaNum means AreaNum+-0. rf.DataBaseFuncs.  When +1,it is described.

ok. is tested.
(ok) is skipping test.
!  Attention
!! Problem now.
stmp3:NeedTempWork3PointsAt k_x,y[stmp3,+1,+2].
**********
DatabeceDelOpe:delx,cel,vec,celsfor1vec().
Focus2 is used in InterSection Operation.
**********
FutureWayOfSpeedUp:
1.get arc centor fast by initial setting.

**********
Problems
1.sqrt(0.0) near0.0butnotjust0.0 brings DOMAIN ERROR.
   if(fabs(d)<0.001){d=0.0;}else{d=sqrt(d);} is good.
2.More needs k_TMPXMAX overflow check.
3.In arccentor().When 2 divlinks are para.
*/
/*ok. input: k_la0:AreaNum
#define k_FORVECSINAREA k_getvecnuminarea();for(k_lfv1=0;k_ar2[k_lfv1]!=0&&k_lfv1<k_AR2MAX;k_lfv1++){k_lj=k_ar2[k_lfv1];
#define k_FORVECSINAREATAIL }
EX: k_FORVECSINAREA
     ...k_lj...        (k_lj is VecNum)
    k_FORVECSINAREATAIL
*/
/*ok.  k_la1 is AreNum
#define k_FORAREAS for(k_la1=0;k_la1<k_arealim;k_la1++){
#define k_FORAREASTAIL }
EX.k_FORAREAS
      ...k_la1...  (AreaNum)
   k_FORAREASTAIL
*/
/*
k_FORNEARVECS
*/
/*CelType in CelRingInVecRing(NotGeoCel)*/
#define CTAREA 3
  /*CelRing3rd:AreaNumb+-0*/
#define CTBFVEC 4
  /*CelRing4th:1BeforeVecNum(NotCelNumb)*/
#define CTMIDRING 5
  /*CelRing5th:MidCelHeadAdr*/

/*CelType in MidCelRing*/
#define CTVECNUM 6
  /*These VecNums are to Same1GeoVec. This Ring inf is for delvec().
  Stored in k_cel[] as MidCelRing.*/
/******************************************/
#include <dos.h>
#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <math.h>
/**DDD*********************/
/*#define k_ k_*/


#define k_SPACE 0x20
	    /*EDEP*/
#define k_PRITES printf
	    /*print test EDEP*/
#define k_PRIWARN printf
	    /*EDEP*/
#define k_PRIERR printf
	    /*EDEP*/
#define k_EXIT exit(0)
	    /*EDEP*/
#define k_FUNCSTKMAX 15

#define k_POITY long
/*or ushort,  pointer type*/
#define k_XTY double
/*or float,  geometric coordinate type*/

#define k_NONARC -1.0
	    /*EDEP*/
#define k_NONPOI -1.0
	    /*EDEP*/
#define k_BIGNUM 1000000.0
	    /*EDEP*/
#define k_AREAMAX 100
#define k_CELMAX 400
#define k_XMAX 200
#define k_TMPXMAX 200
#define k_AR1MAX 40
#define k_AR2MAX 40
#define k_AR3MAX 40
#define k_AR4MAX 40
#define k_AR6MAX 40

/*GeoCelType*/
#define k_LINK 1
#define k_ARC 2
#define k_MID 3
/*GeoCelType*/
#define k_LINK2 4
#define k_ARC3 5
#define k_ARC4 6

#define k_FORVECSINAREA k_getvecnuminarea();for(k_lfv1=0;k_ar2[k_lfv1]!=0&&k_lfv1<k_AR2MAX;k_lfv1++){k_lj=k_ar2[k_lfv1];
#define k_FORVECSINAREATAIL }
#define k_FORAREAS for(k_la1=0;k_la1<k_arealim;k_la1++){
#define k_FORAREASTAIL }

#define k_ARXMAX 8
	/*Focus2*/

#define k_EDGE 1
	   /*?*/
#define k_YES 1
#define k_NO 0

/*Facility A*/
#define k_CANDVEC 10
#define k_SXMAX 10
	/*sense()out*/

#define k_SHARP 0
#define k_RIGHT 1
#define k_BLUNT 2
/*******test***************/
unsigned char k_funcstk[k_FUNCSTKMAX][18];
short k_funcstklvl;/*function stack level*/
/**************************/
double k_pai;/*set in k_init()  3.141592654*/
/**BBB************************/
/*Cell Buffer [AreaNumber]  [VectorNumber]*/
k_POITY k_areapoi[k_AREAMAX];
  /*from [0]  [AreaNumber]. stores 1st vector number. if0,vacant.*/
k_POITY k_cel[k_CELMAX];/*from [1],
	     (cell content)
	      or (pointer to next vector in area. if 0,end.)
	     [VectorNumber,CellNumber=CellAdress]*/
k_POITY k_celpoi[k_CELMAX];/*pointer to next cell.
	     1vector is cell ring by cellpoi[]
	     or garbage pointer(if 0,continues to +1address cell).*/
unsigned char k_celty[k_CELMAX];/*cel type*/
k_POITY k_celgh;/*garbage head of cells*/
k_POITY k_cellim;/*front of cells to be used once. lim address is vacant now*/
k_POITY k_celonuse;/*How many cells are used now. cell_on_use*/
/*CelRing  1st:NextVecNum(0:end) 2nd:GeoNum 3rd:AreaNum+-0
	   4th:1BeforeVecNum(0:1stVec) 5th:MidRingAdr
  MidRing  1st:Dummy 2nd>=:VecNum
  CelType:CTxx
*/

/*Geo Cell [GeoNumber]*/
k_XTY k_x1[k_XMAX],k_y1[k_XMAX],k_x2[k_XMAX],k_y2[k_XMAX];/*from [1],  geo inf*/
			 /*CanHoldMinusValue But +NumberIsGeometric*/
unsigned char k_xty[k_XMAX];/*infomation type*/
	 /*k_LINK k_ARC k_MID*/
k_POITY k_xpoi[k_XMAX];/*pointer to next geo cell. (if 0, end of infmtn.)
		     or garbage pointer(if 0,continues to +1address geo cell).*/
k_POITY k_xgh;/*garbage head of geo cells*/
k_POITY k_xlim;/*front of geo cells to be used once.lim address is vacant now*/
k_POITY k_xonuse;/*How many geo cells are used now. x_on_use*/

double k_x[k_TMPXMAX],k_y[k_TMPXMAX];
     /*CanHoldMinusValue But +NumberIsGeometric*/

k_POITY k_laxn,k_layn,k_arealim;/*AreaDivisionNumber. AccumulationOfThem*/
double k_tox,k_toy;/*drafting totalx,y = total graphic size*/
double k_decx,k_decy;/*decremental x,y  = k_tox/k_laxn */
       /*graphic  origin=(0,0)is downleft. y.+ is up . */

k_POITY k_lr;/*function return value*/
k_POITY k_la0;/*AreaNum*/
long k_lfv1;/*array pointer*/
k_POITY k_lj;/*VecNum*/
k_POITY k_la1;/*k_FORAREAS*/
k_POITY k_lc5;/*add5cel() returns 5thCelAdr*/
k_POITY k_lr2;/*findcelbytype() returns celContent*/
k_POITY k_lglast;/*putvec() returns lastGeoCelAdr*/

k_POITY k_ar1[k_AR1MAX];/*working array. (AreaNum+1)s In.putvec.*/
k_POITY k_ar2[k_AR2MAX];/*working array. VecNumsInArea.*/
k_POITY k_ar3[k_AR3MAX];/*working array. ArroundAreaNum+1s*/
k_POITY k_ar4[k_AR4MAX];/*working array. k_ar2[] backup*/
k_POITY k_ar5[6];/*getareanums(s). GetAreaNumsTo k_ar5[]*/
k_POITY k_ar6[k_AR6MAX];/*working array. */
/***geo********/
double k_px1,k_py1,k_px2,k_py2,k_px3,k_py3;/*k_getvectx()*/
double k_rr,k_rr1,k_rr2;/*radius*/
double k_radtol;/*NearToleranceInCircLine*/
short k_sr1;/*RetValueOf poilinkdist()*/
double k_ontol;/*ifonlink() tolerance. provoke()*/
double k_lentol;/*means 0.0 for length tolerance*/
double k_cstol;/*means 0.0 for cos,sin value tolerance*/
short k_tmpxfront;/*k_x[front] in vvdist()*/
/*double k_arx[k_ARXMAX],k_ary[k_ARXMAX];*//*rf.Focus2*/
/*long k_wd;*//*Focus2 half width*/
/*short k_sll;*//*k_focus2spefunc1()*/
/*long k_ll;*//*k_focus2spefunc1()*/
short k_snoex;/*k_iflinkexist*/
short k_bsv,k_2ndv;/*selectbasevec() base_vec,2nd_vec*/
short k_out1,k_out2;/*crs2linksto2arcs()*/

/** Facility A *****/
short k_newvec[k_CANDVEC][8];
	/*candidate vec to k_x[this]  [][6]is needed in type4*/
k_POITY k_oldvecnum[4];/*old vec elems*/
short k_prio[k_CANDVEC];/*priority*/
short k_sv1,k_sv2,k_sv3,k_sv4,k_sv5,k_sv6;/*tryeval() etc*/
short k_sns;/* sense()>HowManyEdges */
double k_sx[k_SXMAX],k_sy[k_SXMAX];/* sense()> Edges */
short k_proctype;/*2,3,4=2VecProcessType*/
short k_2vecang;/*k_SHARP,k_RIGHT,k_BLUNT*/
short k_v1,k_v2,k_v3;/*ifk()*/

/*****!!from pltr.h************************************/
short pltr2;/*!!from pltr.h*/

/*eee* External params ****k_init()********************/
double k_exparad1;/*prolong() NumbOfProtrdDots MaxDxDyToSense*/
short k_exparas2;/*prolong() MaxNonExist*/
short k_exparas3;/*proc2vec()>ifprotrude() slev:gcbig_lev */
short k_exparas4;/*proc2vec()>ifprotrude() s_limDist */
double k_exparad5;/*proctype2() RightAngLimit*/
double k_exparad6;/* k_sense(...,this) MaxDxDy */
short k_exparas7;/* ifvecexist() MaxNonExistDots */
short k_exparas8;/* tryeval(..,this) ifgcbiglevl */
double k_exparad9;/* tryeval()>ifvecexist(,this,) dstep=StepSize */
double k_exparad10;/* 2vec()etc. TolToExcludeSameMidPoi */
double k_exparad11;/* ifk() Veryshortvec is neglected. */
double k_exparad12;/* crs2linksto2arcs()>LimBtwnCrsAndLinkTip*/
double k_exparad13;/* ifk() NearLimToCrsPoi*/
double k_exparad14;/* 2vec(),3vec()>arctan() TransLen*/
double k_exparad15;/* 2vec(),3vec()>arctan() NewArcLenLim*/
short k_exparas16;/* stp=(this) FIX.  InfSizeOf1NevCanddtVec*/
double k_exparad17;/* proc2vec()>ifonvecwide>WidenTolIn2CrsPointsCase*/

/**FFF**************************************************************/
k_showarea(k_POITY,k_POITY);/*show k_area[l1 to <=l2]*/
k_showcel(k_POITY,k_POITY);/*show k_cel,celpoi,celty[l1 to <=l2]*/
k_showx(k_POITY,k_POITY);/*show x1,y1,x2,y2,xpoi,xty[l1 to <=l2]*/
k_showareastring(k_POITY);/*ShowAreaString(AreaNumber)*/
k_showcelring(k_POITY);/*ShowCellString(VectorNumber) for 1 vector ring*/
k_showxstring(k_POITY);/*ShowGeoString(GeoNumber)*/
k_showcelgarbage();
k_showxgarbage();
k_showtmpx(short,short);/*show k_x[s1 to =s2]*/
k_showar1();
k_showar2();
k_showar3();
k_showar4();
k_showar6();
k_shownewvec(short);/*(n)*/
k_showoldvec();
k_shownewvecall(short);/*(nlim)*/
k_showsx();
k_push(str);/*push func name for check write func call.    !!?(str)*/
k_pop();/*pop func name for check write func call*/
k_showfunc();/*show func call*/
k_putlinkdots(short,short);
  /*ok. for test. putlinkdots(sp1,sp2)->plar_*/
k_putarcdots(short,short,short,double,short);
  /*ok. for test. putarcdots(sp1,sp2,scen,dr,stmp3)->plar_*/
/***tiny operation*****************/
k_transar2to4();/*slow*/

/****from pltrace.c pltr2.c etc.******************************/
double plcos2d(double,double,double,double,double,double);
   /*RetCos (-1.0 to +1.0)
   pltr2:gaiseki(+:(Ang<1-c-2 is clockws and less than pai),
		 -:(Ang<1-c-2 is clockws and over pai)) */

/**********************************************/
k_init();/*initialyse*/
k_cleararea();/*ok.*/
k_clearcel();/*ok.cell clear. set celgh.lim,onuse */
k_clearx();/*ok.geo clear. set xgh,lim,onuse*/
k_POITY k_makex();
    /*ok.make 1 geocel.retGeoNum.not reg x1[],0war. xpoi[],xty[]=0
    ->k_xgh,k_xonuse,k_xlim*/
k_POITY k_delx(k_POITY);
   /*ok.del 1 lg geocel. retNextXcel(GeoNum) 0meansEndOfXcell  xonuse--
   ->k_xgh,k_xonuse*/
k_POITY k_make1celring();/*ok.make 1cel ring. ret CelAdr,0Fail
  ->k_celgh,k_celonuse,k_cellim;  k_cel[new]=0;k_celty[new]=0
  Used in MidRing(=ChuukannRing=stores lvs for each area)*/
k_POITY k_add5cel(k_POITY);/*ok.Make5CelsToArealaAtEndOfVecsString. sets areapoi[]
	  (AreaNum+-0)   RetNewVecNum,0ovr.GiveInf1st3rd4thCel.
	  GiveNoInf2nd5thCel  ->k_lc5:5thCelAdr,k_celgh,k_celonuse,k_cellim*/
k_POITY k_delcelsringdirect(k_POITY);
       /*ok.DelCelsRingDirectly(CelAdr).CanDel1CelRing.
	Ret.1:good,0:fail  ->k_celgh,k_cellim,k_celonuse*/
k_POITY k_delcelsfor1vec(k_POITY,k_POITY);/*ok.DelCelsFor1Vec.Ret1Suc0Fail.
		 (AreaNum,1BeforeVecNum)lvb=0:Del1stVec. sets areapoi*/
k_POITY k_nextvec(k_POITY);/*ok.RetNextVecNumInCelBuf,0:NoExist. (VecNum)*/
k_POITY k_nextcel(k_POITY);/*ok.RetNextCellAdrsInCelBuf,0:NoExist. (CelAdr)*/
unsigned char k_thisceltype(k_POITY);/*(ok)RetCellAdrsInCelType. (VecNum)*/
k_POITY k_nextx(k_POITY);/*ok.RetNextGeoCel,0:NoExist. (GeoNum)*/
k_POITY k_imbedcel(k_POITY);/*ok.ImbedCelAftCel[l(celadr)]. RetNewCelAdr,0:fail*/
k_POITY k_lastcel(k_POITY);/*ok.RetLastCelAdr,0:fail. (POITY.VecNum)*/
k_POITY k_delcel(k_POITY);/*ok.delCel(1BfrCelAdr).RetNextCelAdr,0:fail*/

k_POITY k_getcel(k_POITY);/*ok.RetCelContent(CelAdr)*/
k_putcel(k_POITY,k_POITY);/*ok.PutCelContent(CelAdr,Contnt)*/
unsigned char k_getcelty(k_POITY);/*ok.RetType(CelAdr)*/
k_putcelty(k_POITY,unsigned char);/*ok.PutType(CelAdr,Type)*/
k_POITY k_getcelpoi(k_POITY);/*ok.RetPointer(CelAdr)*/
k_putcelpoi(k_POITY,k_POITY);/*(ok)PutPointer(CelAdr,Poi)*/

k_getx(k_POITY,short);/*Get4(2)k_x1[lg(GeoNum)]To4(2)k_x[s].2points.(GeoNum,s)*/
k_putx(k_POITY,short);/*Put4(2)k_x[s]To4(2)k_x1[lg(VecNum)].2points.
	 even,odd_well.(GeoNum,s as k_x[s])*/
k_putxpoi(k_POITY,k_POITY);/*ok.([here],obj)*/
k_putxty(k_POITY,unsigned char);/*(ok)*/
unsigned char k_getxty(k_POITY);/*(ok)*/
k_POITY k_getxpoi(k_POITY);/*(ok)(GeoNum)*/

k_POITY k_findcel(k_POITY,k_POITY);
   /*ok.FindCel(StrtCelAdr,Objct)in1Vec.  skip1stCel
   RetCelAdr,0:No. ->k_lr:1BefCelAdr.NotTestlc(1stCel)*/
k_POITY k_findcelbytype(k_POITY,unsigned char,unsigned char,k_POITY);
  /*ok.FindNextCelByType       skip1stCel  ->k_lr2:CelContent
  (FromAt,TypeMin<=,<=TypeMax,Limit=RingHeadAdr)  RetCelAdrOr0(NotFound)
  ->k_lr:1BefCelAdr.NotTestlc(1stCel)*/
k_POITY k_putvec(short,short);/*ok.PutVecToArea+CelRings+MidRing+Geo.
       (from k_x[s]7points link or arc,1Tmp)
       RetGeoNum,0:fail    ->k_lglast:LastGeoCelAdr
	 k_x,y[s+]  +0,1:tip,2:mid(orNONARC),3:RepCentor,4x:length,
	 4y:VecAng1000, (Arc=> +5:Arc.centor, 6x:Radius  6y:ArcCentAngRadian )
       WhenArc,CentorPointMustBeGivenTo k_x,y[s+5],RadiusMust k_x[s+6].*/
k_POITY k_delvec(k_POITY);
/*ok.Del1VecAllInf(VecNum(Not1befor)) Ret1:Suc,0Fail*/
k_POITY k_getvec(k_POITY,short);/*ok.GetVecTo k_x[s](VecNum,k_x[s]).
    Ret1GeoNum,0Fail.  ->k_lr:InfLength(PointsNumber)*/
/*************/
k_POITY k_putcelatr(k_POITY);
       /*ok.FindLastCelInVec and Imbed1CelAftIt. (VecNum) This is Appending.
	 RetImbeddedCelAdr,0:Fail  Use k_putcel()etc aft this func.*/
short k_getcelatr(k_POITY,unsigned char,unsigned char);
       /*ok.get k_cel[] when k_celty[] is =tymin to =tymax
       to k_ar6[] till <ar6[]=0;  (Vecnum,tymin,tymin)  RetInfsNumb*/
k_delcelatr(k_POITY,unsigned char,unsigned char);
       /*ok.del k_cel[] when k_celty[] is =tymin to =tymax
       to k_ar6[] till <ar6[]=0;  (Vecnum,tymin,tymin)
       ! Must exist 3cels. 1st cel is not deleted.
       This is to delete attribute cells that are aft 3first cels.*/
k_POITY k_imbedxatr(k_POITY,short);
   /*ok.Imbed 1GeoCell. k_x[s] to aft lg GeoCell.(lg=1BeforGeoNum,k_x[s,+1])
   Ret NewGeoNum=(Aft lg),0:Fail.    lg neednot last xcell.append ok.*/
short k_getxatr(k_POITY,short,unsigned char,unsigned char);
   /*ok.get GeoInf to k_x[s] when k_xty in =min,=max
   RetInfsNumb(=2*n)   Scans through string starting [lg]*/
k_delxatr(k_POITY,unsigned char,unsigned char);
   /*ok.del GeoCels when k_xty in =min,=max
   Scans through string starting [lg]
   !Does not del 1stGeoCell.  This is to delete attribute GeoCells.*/
k_POITY k_getxnum(k_POITY);/*ok.RetGeoNumFromCellBuffer(VecNum)*/
k_POITY k_lastx(k_POITY);/*ok.Ret last GeoCellAdr(GeoNum), 0:Fail*/

/****AreaOperation. FOREACH**************************/
k_getvecnuminarea();/*VecNumsInArea to k_ar2[] till 0. <-k_la0:AreaNum*/
k_arroundarea(k_POITY,short);/*GetArroundAreaNum+1sTo k_ar3[]till0.la is +-0.
(la:AreaNum(+-0),sw=1:incldSelf(out.with+1),0:NonIncld). <-k_laxn,k_layn:AreaDivNum*/
k_POITY k_spefunc1(k_POITY,k_POITY,k_POITY,short);
k_pairvecsarndarea(k_POITY,short,short);/*AllPairsVecOperationArnd1Area
		    l:SelfAreaNum  sopnum:OperationTypeNumber
		    sw=1:incldSelfArea.vs.SelbArea, 0:NonIncld*/
k_pairvecoper(k_POITY,k_POITY,short);/* 1PairVecOperation
	lk:VecNumInSelfArea+-0  k_lj:VecNumInArroundArea, sopnum:OpeTypeNum*/
k_pairvecoper(k_POITY,k_POITY,short);/* 1PairVecOperation
k_corresareas(short,short);/*ok.CorresAreas->k_ar1[](AreaNum+1 till 0)
   (s as k_x[s],1temp as k_x[1temp])
   <- k_x[s]3points link or arc    0.0<=x,y<=k_tox,y
   WhenArc,CentorPointMustBeGivenTo k_x,y[s+3],RadiusMust k_x[s+4].*/
k_addar1(k_POITY);/*add la(=AreaNum+1) to k_ar1[].NotDupl.*/
k_getareanums(double,double);/*GetAreaNum+1sTo k_ar5[]till0 from point (x,y)*/
/***Database+Geometric********************************************************/
k_POITY k_putvect(double,double,double,double,double,double,short,short);
  /*ok.PutVecTotal(6xy,17TMP,sw).
  sw=1:regCenRadiusLenAngReglateArc,0:no   RetGeoNum,0:fail
  sw=1:GeoCelTypeSequence:LINK,LINK2 or ARC,MID,ARC3,ARC4.
  sw=0:GeoCelTypeSequence:LINK or ARC,MID.
  GeoCelContents:
   Arc:+0,1:tip,2:mid(orNONARC),3:RepCentor,4x:length,
       4y:VecAng1000, (Arc=> 5:Arc.centor, 6x:Radius  6y:ArcCentAngRadian
   Link:+0,1:tip,2:RepCentor,3x:length,3y:VecAng1000
  */
k_POITY k_getvects(k_POITY,short,short);
  /*ok.get 3points/7points by sw=3or7 into k_x,y[s+]
    (VecNum,Out4(3)/7,Sw)         Ret1GeoNum,0Fail
       k_x,y[s+]  +0,1:tip,2:mid(orNONARC),3:RepCentor,4x:length,
       4y:VecAng1000, (Arc=> 5:Arc.centor, 6x:Radius  6y:ArcCentAngRadian )
     InLinkCase,+2isDummyUsing.*/
k_POITY k_getvectx(k_POITY,short);
 /*ok.get 3points (VecNum,4TempWork)
  Ret1GeoNum,0Fail ->(double)k_px1,k_py1,to k_py3*/

/******geometric func****(y.posi is up.)********************/
k_rightpoint(short,short,short);
  /*ok.RightPoint.(sp,slink,sout).
  (k_x[sp]:point,k_x[slink]:link,k_x[sout]:out)*/
long k_llcross(short,short,short,short);
     /*ok.2lineCrossPoint(k_x[sl1]:link1=2Poi,k_x[sl2]:link2=2Poi,
       k_x[sout]:CrosPoi,st3:temporal3k_x[st3+0,+1,+2])
       (sl1,sl2,sout1,st3) Ret:1Cross0Para
!!yet.2links are on 1 line and has common part.*/
k_rot90(short,short,short);
  /*ok.Rotate90.(sobj,scen,sout).k_x[sobs]Arroundk_x[scen]ToOutk_x[sout]*/
k_vertdiv2link(short,short,short,short,short);
     /*ok.VertDivLine.(sp1,sp2,sout1,sout2,st).
     (k_x[]link1,link2,out1,out2,1temp)*/
long k_arccentor(short,short,short,short,short);
   /*ArcCentor Ret:1:good,0NoCentor
   (k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
long k_lccrossd(short,short,short,short,double);
   /*ok.LineCircleCrossDirect Ret1:good,0No
       (CirCentr,CenRightpoiToLink,OutCross2Points,1Temp,InputArcRadius) */
long k_lccross(short,short,short,short);/*ok.LineArcCross2Points.
  AtentnNot.k_lccrossd() Ret=1(cros),2(Near),0(NotCrs)
  <-k_radtol:RadiusTolerance  ->k_rr:radius
  (LineArcBy3Poi,LineArcBy3Poi,OutCros2poi(OnlyRet=1,2),12Temp)*/
long k_cccross(short,short,short,short);
	   /*ok.CircCircCross Ret1:good,2:Near,0:NotCrs
		 <-k_radtol  ->st22+9(sc1Side),+19(sc2Side):ArcCentr
		 ->(double)k_rr1:RadiusSc1,k_rr2
		 (sc1:Arc3poi,sc2:Acr3Poi,sout2:2CrsPoi,st22:22temp)*/
k_arcdivpoi(short,short,short,double,short);
    /*ok.(tip1,tip2,centor,ratio,out)
    DivPoiByDratio(0.0-1.0isInter) Dire+ is sp1 to sp2. Out k_x[sout1]*/
double k_pltangl2d(double,double,double,double,double,double);
    /*ok.(dx1,dy1,dx2,dy2,dcx,dcy)
    Ret radianAngle 0.0 to +2*pai for ang<1-c-2 clockws is +.  always +.*/
k_regulatearc(short,short);/*ok.RegulateArcTipLocation. make tip1-mid-tip2 clockws
  <-->k_x[sa]:tip1,k_x[sa+1]:tip2,k_x[sa+2]:mid   (linkarc:k_x[sa3],10temp)
  ang<tip1-cen-mid and ang<mid-cen-tip2 must be less than pai.!!danger*/
long k_ifonarc(short,short);/*ok.Ret1:PoiIsOnArc,0:No. (sa3:arc3poi,sp:point)
    Point=spMustOnTheCircle.  rf.ifonarc2()*/
long k_ifonlink(short,short);/*ok.Ret1:PoiIsOnLink,0:No. (sl2:link2poi,sp:point)
    Point=spMustOnTheLink.     rf.ifonlink2()
    <-k_ontol:tolerance  0 is bad for horizn/vert link*/
double k_2poidist(short,short,short);/*ok.RetDistanceBtwn2Points.
     (Poi1,Poi2,Switch(2:precise_power2,1:precise,0:approx))*/
double k_poilinkdist(short,short,short,short);/*ok.RetDistanceBtwnPointLink.
  (Point,2LinkTips,1Temp,SwToEvalDist:0(aprx),1(sqrt),2(pow2))
  ->(short)k_sr1=sl2,sl2+1 or st1(NearestPoi) <-k_ontol:tolerance */
double k_lldist(short,short,short,short);/*ok.RetDistanceBtwnLinkLink.
	      (Link1,Link2,4Temp,SwToEvalDist:0(aprx),1(sqrt),2(pow2))
	      <-k_ontol:tolerance */
long k_linkrizearc(short,short,short);/*ok.MakeArcToLinks.
	     RetNumbOfLinks,0:NotArc,1:NotDiv
	     (Arc,Out:k_x[sout+0,1*3,2*3,..,(n-1)*3],11Temp)
	     if Ret=0or1,k_x[soutn] is vacant.
    ! Must to use regulated arc.
    if Ret=2 then k_x[soutn],k_x[(soutn+1)*3]. NextUse is from [soutn+3*Ret]*/
double k_vvdist(short,short,short,short);/*ok.RetDistBtwn2Vecs.
   ->(short)k_tmpxfront:k_x[front]   next use is from k_x[k_tmpxfront]
     ! Must to use regulated arc.
     Safe next Tmp is +71(=10linksInEachSideArc*3points*2bothSideVec+11)
     k_tmpfront=st11m+11+nTotalLinks(dividedFromArc)*3points;
     EX. k_vvdist(,,6,) TotalLinks are 6,then k_tmpfront=6+11+6*3=35;
	 k_x[35] is vacant.
     But TMP is TMP. Aft This Func ,can use Tmp.  EX.k_x[6] can be used next.
   (Vec1By3Points,Vec2By3Points,11MoreTemp(till <k_tmpxfront)
    ,SwToEvalDist:0(aprx),1(sqrt),2(pow2))
   EX.k_regulatearc(0,6);k_regulatearc(3,6);
      d=k_vvdist(0,3,6,1);k_PRITES(" d=%f",d);*/
double k_veclen(short,short);/*ok.RetVecLength  LinkNeedNONARCat k_x[sv3+2]
    (VecBy3Points,Sw(2:precise_power2,1:precise,0:approx))
    !!NotFixedOnArc  rf.k_2poidist()*/
k_repveccen(short,short,short);/*ok.RepresentativeVecCentorAboutOnVec
 (Vec,Out1Point,10Temp)
  ! Arc Must regulated.
  !!slow on arc  !!algorthm is not fixed.*/
double k_vecang(short);/*(ok)returns ang1000  (s as k_x,y[s to s+1])*/
double k_arccenang(short,short);/*ok.Chuushinnkaku
  RetArcCentoralAngle(Arc,10Temp)
  ! MustUseRegulatedArc  !!slow
    Ret radianAngle 0.0 to +2*pai for ang<1-c-2 clockws is +.  always +.
    if NotArc or HaveNoCentor then Ret 0.0
    ! ->st10+9:centor*/
long k_ifnearvecs(short,short,double,short);
	       /*ok.Is2VecsNear. Ret1:Near,0:No.
	       (Vec1,Vec2,Tolerance,11moreTemp)*/
long k_vvcross(short,short,short,short,short);
  /*ok.but.yet.VecVecCross. VecIsLinkOrCurve(=Arc).
  RetCrossPoiNum=2,1,0,WithSwitch.(vec,vec,Out2,Temp22
  ,Sw(1:OnVecCheck,0:NoCheck))
  ->k_x,y[sout or+1]=k_NONPOI(in sw==1&&CrsPoiIsNotOnVec&&(l.vs.c or c.vs.c))
  if 2 [sout,+]points are same(Ret=2), then tangential point.
!!yet.2links are on 1 line and has common part. llcross()problem
!!yet.in LinkArc when link goes through centor of arc.
!!yet.in ArcArc when Dupl Arc Pattern.
*/
long k_ifpointon2vecswide(short,short,short,double);
 /*ok IsPointOnBoth2VecsWithStretchingDtolAt4Tips. (sp,svec1,svec2,dtol)
 Ret1:yes,0:no*/
long k_ifpointonvecwide(short,short,double);
 /*ok IsPointOnVecWithStretchingDtolAt2Tips. (svec,sp,dtol) Ret1:yes,0:no*/
long k_ifonlinkwide(short,short,double);
 /*ok IsPointOnLinkWithStretchingDtolAt2Tips. PointMustOnLink.
 (svec,sp,dtol) Ret1:yes,0:no*/
long k_ifonarcwide(short,short,double);
 /*ok IsPointOnArcWithStretchingDtolAt2Tips. PointMustOnArc.
 (svec,sp,dtol) Ret1:yes,0:no*/
/***************************************/
long k_ifonlink2(short,double,double);
  /*ok.Ret1:PoiIsOnLink,0:No.
    (sv:link2poi as k_x[sv,sv+1],(double)point_x,y)
    Point_x,y MustOnTheLink.
    <-k_ontol:tolerance  0 is bad for horizn/vert link*/
long k_ifonarc2(short,double,double);
  /*ok.Ret1:PoiIsOnArc,0:No. (sa3:arc3poi,sp:point_x,y)
    Point=spMustOnTheCircle.*/
/*************************/
/** FACILITY A A A A ******************************************/
k_getnearpoi(short,short);
  /*ok.GetNearPoints(sv1:vec1 as k_x[sv1],sv2).
    ->k_sv1,2,3,4 as k_x[k_sv1.etc]  1,2:sv1_tips  3,4:sv2_tips  1,3:near_pair*/
long k_div2arcfast(short,short,short,double,short,short);
  /*ok.DivideArcto2.(tip1 as k_x[this],tip2,cen,d_radius,sout,stmp1)
  NeedNotConcernTheOrderOf2Tips.
  ArcInnerAnglMustBe<pai
  RET 1:good,0:fail*/
short k_poineartip(short,short,short);
  /*ok.GetNearPoi(sp1,sp2,spoint) Ret=<sp1 or sp2>nearpoi. Ref:poidisttip()*/
long k_getangmidby3poi(short,short,short,short);
  /*ok.GetDev2poiOfAng<sp1,scen,sp2. Ret1:good0:fail (sp1,scen,sp2,soutpoi)*/
double k_cosby3poi(short,short,short);
  /*ok.Ret cos value by 3 poi.(sp1,scen,sp2)  if(1vecLen==0)returns 1.0*/
long k_getinterarcbymidpoi(short,short,double,double,short,short,short);
 /*ok.!!YET2vecIs0Len,2VecIsOn1Line,2VecHasCommonTip,MidPoiIsCrspoi.
 <-k_sv2,4 from k_getnearpoi() (sv1,sv2,xmid,ymid,sout3,scrs,st5)
 ->k_sv5,6:ArcLink,ArcArcConnectPoint.Ret:1:good,0:fail
 5 is on 1,2.  6 is on 3,4. 1,3 is near. 1,2 is vec. 3,4 is vec.
 ->k_rr:ArcRadius  ->k_x[st5+4]:ArcCentr
 sout3:sv1sideArcConnectPoi,sout3+1:sv2side,sout3+2:ArcJustMid*/
k_putoldvec(short,k_POITY);
 /* (ok)sets candidates array.
 (i,lv)i:part_of_canddt,lv:vec_num */
k_putnewvec(short,short,short,short);
 /* (ok)sets candidates array.
 (n,i,sv,sprio)n:canddt_num,i:part_of_canddt,sv:vec1sttip,sprio:priority */
k_puttmp3x(short,short,short,short);/*(ok)k_x,y[s,+1,+2]=k_x,y[sv1,2,3];
	      if s3=-1 NONARC*/
k_sendpoi(short,short);/*ok.send poi (sfrom,sto)*/
long k_sense(short,short,double);/*ok.sense from sp1 to sp2
 (sp1:tip1 as k_x[this],sp2:tip2,MaxDxDy(PosiValue))
 Ret 1:exist,0:no  <-k_ontol ->k_sns:HowManyEdges
 -> k_sx[k_sns],k_sy[k_sns]:Edges */

/*******!!MustFor pkmd.c*****/
unsigned char k_read(long,long);/*!! Must put in pkmd.c*/
short k_ifgcbig(long,long,short);/*!! Must put in pkmd.c*/
/*************************/
k_vecdisp();
k_1vecdisp(short,short,short);
  /*(sv1 as k_x[sv1]=tip1,sv2=tip2,sv3=mid)  ex.(1,2,3)(1,2,-1)(1,1,-1)
  if sv3==-1 disp link. if(sv1==sv2){pl2x[l]+=3.0;pl2y[l]+=3.0;}*/
/***/
long k_iflinkexist(short,short,double,short,short);
 /*ok.IfLinkExist sp2 from sp1.
 (sp1:tip1 as k_x[this],sp2:tip2,d_StepDxDy,s_MaxNonExist,s_gcbig_lev)
 Ret 1:exist,0:no  ->add k_snoex:NonExistDegree(withLimit=slim) <-k_ontol*/
k_prolong(short,short,short,double,short,short);
 /*ok.Prolong sp2 direfrom sp1.
 ->sout as k_x[sout]:NewTipPoi   DxDyStep is 1.
 (sp1:fromoffrom,sp2:justfrom,newtip_out,MaxDxDy,MaxNonExist,gcbig_levl)
 (?)BetterToReformAlgrthmTheCaseOf(slim>=2)
 Ifever sp2 is vacant, ans is sp2.
 */
long k_ifarcexist(short,short,short,double,double,short,short,short);
  /*ok.Ret 1:exist,0:no
  (stip1,stip2,scentr,dradius,dstep,stmp3,slim:MaxNonExist,slev:gcbig_lev)*/
long k_ifvecexist(short,short,short,short,double,double,short,short,short);
 /*ok.Ret 1:exist,0:no  ->add k_snoex:NonExistDegree
  (stip1,stip2,smid:RefOnlyNONARC,scentr,dradius,dstep,stmp3
   ,slim:MaxNonExist;slev:gcbig_lev)*/
long k_ifprotrude(short,short,short,short,short);/*ok.IfVecProtrudesCrospoi
 (s_vec,s_crospoi,stmp1,slev:gcbig_lev,s_limDist) Ret 1:yes,0:no*/
/******************/
long k_proc2vec(k_POITY,k_POITY,short,short,short);
  /*ok.process for 2vecs intersection.
   Ret 1:processed,0:no (lv1,lv2,sv1,sv2,stmp_n)*/
long k_proctype2(k_POITY,k_POITY,short,short,short,short);
  /*ok.ProcessType2(lv1,lv2,sv1,sv2,scrs,st_n) Ret?!!*/
k_tryeval(short,short,short);
  /*(ok)TryEval(NumbOfCandidates,stmp,slev:gcbig_levl)
  <-k_newvec[][],k_oldvec[][],prio[]*/
k_2vec(k_POITY,k_POITY,short,short,short,short);
   /*ok.<-k_sv1,2,3,4 from k_getnearpoi() by proctype2()
      (VecNum1,VecNum2,svec1,svec2,crospoi,stmp_n)*/
k_3vec(k_POITY,k_POITY,short,short,short,short);
   /*ok. (lv1,lv2,sv1,sv2,scrs,st_n)
      (VecNum1,VecNum2,svec1,svec2,crospoi,stmp_n)
   lv1,sv1:ProtrudeSide */
k_4vec(k_POITY,k_POITY,short,short,short,short);
   /*ok. (lv1,lv2,sv1,sv2,scrs,st_n)
      (VecNum1,VecNum2,svec1,svec2,crospoi,stmp_n)
   <-k_exparad12:LimBtwnCrsAndLinkTip
   */
k_mknewvec(short,short,short,short,short,short,short);
  /*ok.MakeNew1VecAsEval (n,i,sv,sprio,sp1,sp2,smid) if smid=-1 NONARC
    k_putnewvec(n,i,sv,sprio);k_puttmp3x(sv,sp1,sp2,smid);*/
/********************************/
long k_linktanpoi(short,short,short,short,short);
 /*ok.GIVEN=Link,TangentialLink,TanPoi
 GET=ConctPoiOnLink,CentrOfTangentialArc,ArcMidPoi
 RET 1:good,0:fail
 (sl,stl,stp,sout3,st6)(link,tanlink,tanPoiOnTanLink,sout3,stmp6)
 sout3:ConstPoiOnSL,sout3+1:tangntialArcCentor,sout3+2:tanArcMidPoi
 stp must be on stl.
 NeedNot getnearpoi() before.
 */
k_transvec(short,short,double,short,short);
  /*ok.TranslateLink sl as link to dire point sp with dist d.
  (sl,sp,d,sout2,st1) if(sp is on sl)NotMove.
  sout2,+1:NewLink2Tips. sl(+1) to sout2(+1).*/
long k_linktan(short,short,short,short,short,short);
 /*ok.GIVEN:Link,TanLink,PointOnLink,AnyPointOnTanLink.
   GET:AcrCnctPoiOnTanLink,ArcCen,ArcMid
  (sl,stl,sp,stp,sout3,st7)(Link,TanLink,PointOnLink=NewArcTip
  ,ReprsnttvPointOnTanLink,sout3,stmp7)
  Arc is generated to stp existing side.
  stp must not be at crspoi btwn sl,stl.  RET 1:good,0:fail
  Arc can be 2. But stp side arc is generated.
  sout3:ConctPoiOnStl,sout3+1:NewArcMid,sout3+2:NewAcrCen.
  ->k_rr:NewArcRadius
  Attention:NewArc=sp,sout3,sout3+1(mid)
  Attention:NotChangeSl,Stl.
 */
long k_fillet(short,short,short,short,short);
 /*ok.Mentori(sl1,sl2,sp,sout2,st10)
 (link1,link2,MentoriPoi,OutMentori2Tips,stmp10)  Ret,1:good,0:fail.
 There can be simpler+faster way with that (sp is as MidOfMentori).
 ->sout1:sl1 side,sout1+1:sl2 side.
 */
long k_linklink(short,short,short,short,short,short,short,);
 /*ok.ContinuousArc btwn linklink.Ret1:good,0:fail.
 (sl1,sl2,sp1,sp2,scrs,sout4,st7)
 (link1,link2,poi1,poi2,CrossPoiBtwn2Links,sout,stmp7)
 sp1:PoiNearCrsPoiOnLink1,sp2:PoiNearCrsPoiOnLink2.
 MustGiveCrsPoi as scrs.
 VerySimilar linktan(). Can program with linktan().
 The Location of sp1,sp2 must not at CrsPoi.
 sout4:=sp1 or sp2(near one)=tip1,sout4+1:tip2,sout4+2:ArcMid,sout4+3:centr.
 ->k_rr:NewArcRadius
 */
long k_arctanpoi(short,short,short,short,double,short,short);
 /*ok.ArcWithGivenTangentialPoi(sa,stl,stp,sc,dr,sout3,st5)
 (arc(NeedNotGiveMidPoi),TanLink,PointOnTanLink(FixedNewArcTip),sa's centor
 ,sa's radius,sout3,stmp5)
 sout3:NewArcTip(OtherTip is stp),sout3+1:NewArcMid,sout3+2:NewArcCentr
 ->k_rr:NewArcRadius
 If sout3 is nonarc, sout3+1 is k_NONARC and sout3+2 has no_meaning.
 ! So,You need check k_NONARC aft this func.
 !!yet. If sa and stl crosses, result is not good.
 Ret1:good,0:fail.
   When Sc is on the line that is NormalToStlPassingStp,
       Result is good, but is not useful.
 */
long k_arctan(short,short,short,double,double,double,short,short);
 /*ok.GetTangentialArcBtwnArcAndLink. Unknown:NewArc2Tips
 (sa,stl,sc,dr,ddef,dlim,sout4,st12)
 (OldArcAs2Tips(NeedNotMid=3rdPoi),TanLink2Tips(NeedNot3rdPoi),OldArcCEntr
  ,OldArcRadius,StlTranslationLength=>NewArcTipLocatesThere,NewArcLengthLim
  ,sout4,stmp12)
  ->k_rr:NewArcRadius
 sout4:TipBtwnOldArcAndNewArc,sout4+1:NewArcTip=TanPoi,sout4+2:NewArcMid
 sout4+3:NewArcCentr
 Stl is translated ddef todire sc. This line is crossed to OldArcSa.
      CrossPoi is sout4=ArcTip.   If NotCross,Fail.
 If OldArcBoth2Tips are near within ddef to stl, then fail.
 If AprLengthBtwnNewArc2Tips are >= dlim, then fail.
 Ret1:good,0:fail.
 */
/************/
long k_iflink(short);/*ok.if(sv=vector(check.sv+2))is link RET1 else RET0.*/
short k_selectbasevec(short,short);
 /*ok.RET sv1 or sv2.  ->k_bsv=Base=longer,k_2ndv=shorter. RET=k_bsv*/
long k_linktandef(short,short,double,short,short,short);
  /*ok.stl is translated ddef to sl. It and sl cross poi is NewArcTip.
  (sl:link,stl:TanLink,ddef,stp:ArcSideOnStl,sout4,st8)
  Arc is generated to stp existing side.
  stp must not be at crspoi btwn sl,stl.  RET 1:good,0:fail
  Arc can be 2. But stp side arc is generated.
  ->sout4:NewArcTipPoiOnStl,sout4+1:NewArcMid,sout4+2:NewAcrCen
    ,sout4+3:NewArcTipOnSl.
  NewArc:sout4+3,sout4,sout4+1(mid)
  ->k_rr:NewArcRadius
  Attention:NotChangeSl,Stl.
  */
long k_arcarcvalley(short,short,double,double,short,short);
    /*ok.Case there are 2Arcs as a valley. 2NewTangentialArcs are generated.
    (sa1,sa2,ddef=TransltDifFromTanLine,dlim=NewArcLenthLim,sout13,st36)
    RET1:good,0:fail
    sa1,sa2:Arc3Poi(2Tips,1Mid)
    <-k_radtol:if this is small, arc cross is not found.
    ->SA1_SIDE  ARC:sout13,+1,+2(=mid)
  sout13:NewOldArcTip,sout13+1:NewArcTanTip,sout13+2:NewArcMid,sout13+3:NewArcCen
    +9:OldArcDistTip,+10:OldArcMid
    SA2_SIDE    ARC:sout13+4,+5,+6(=mid)
sout13+4:NewOldArcTip,sout13+5:NewArcTanTip,sout13+6:NewArcMid,sout13+7:NewArcCen
    sout13+8:poiP(On2OldArcCentersPassinglink. And OnTangentialLine)
    +11:OldArcDistTip,+12:OldArcMid
    */
long k_crs2linksto2arcs(short,short,short,short);
  /*ok.Type4 2CrsLinks to 2Arcs. RET1:good,0:fail
  (sl1,sl2,sout8,stmp3)
  <-k_exparad12:LimBtwnCrsAndLinkTip
  sl1's sl1 side Arc+SmallLink
  sout8:ShorterTip=ArcTip,sout8+1:Crspoi
  ,sout8+2:ArcTip=SmallLinkTip,sout8+3:SmallLinkTip
  sl1's sl1+1 side Arc+SmallLink
  sout8+4:ShorterTip=ArcTip,sout8+5:Crspoi
  ,sout8+6:ArcTip=SmallLinkTip,sout8+7:SmallLinkTip
  ->(short)k_out1:Is(shorter side link(in sout8to+3))sl1 or sl2.
  ->(short)k_out2:Is(shorter side link(in sout8+4to+7))sl1 or sl2.
  */
long k_ifk(short,short,short,short);
  /*ok.IfPatternK  RET1:yes,0:no (sv1,sv2,sv3,stmp6)
   sv1,2,3 must have 3points(tip1,tip2,mid/k_NONARC)
   <-k_exparad11:Veryshortvec is neglected.
   <-k_exparad13:NearLimToCrsPoi
   ->k_v1,2,3:=(sv1,2,3ByChangingOrder. k_v3:MasterVec)
   */
long k_gettanlink(short,short,short,double,short,short);
 /*ok.GetTangentialLinkFromSpToSaArc
 ->sout4,+1:TanPois,+2:NewArcMidPointIn1TanLinkCase(=:RET=1).
 ,+3:NewArcAnotherTip=OldArcTip
 RET=NumbOfPoints(0,1or2),0:NonTanPoi=Fail.  Sa must have 3point(tip1,2,mid)
 (sp=point,sa=arc,sc=centr,dr=ArcRadius,sout4,st4)
 */
short k_poidisttip(short,short,short);
  /*ok.RET:distantTip sp1 or sp2 from point spb. (sp1,sp2,spb)
  Ref:poineartip()*/
long k_prock(short,short);
  /* ok.ProcessK(sout6,stmp9)  <-k_v1,2,3(3:MasterLink, 1,2:ToArc)
  RET1:good,0:fail
  ->sout6:ShortVecDistantTip=NewArcTip,+1:NewArcMid,+2:NewArcTipOnLongVec
   ,+3:LongVecDistantTip,+4:TanPoiOnNewArc,+5:NewArcCentr
  ->k_rr:NewArcRadius
  NeedMoreModification:AngCheck(@v1,@v2),SameLengthCase(@v1,@v2)
  !!Yet:NewArcJustMidAft gettanlink()
  */
long k_arcarc(short,short,short,short,double,double,short,short);
  /*ok.GetContinualArc(Link)Btwn2Arcs. NewLinkCase:3rdMidPoiIsk_NONARC
  RET1:good,0:fail      (sa1,sa2,sc1,sc2,dr1,dr2,sout8,st16)
  (sa1=Arc3poi(t,t,mid),sa2,sc1=cen,sc2,dr1=radius,dr2,sout8,stmp16)
  ArcsNeed3points(TipTipMid)
  ->sout8:OldSmallArcTip,+1:NewArcTipOnSmallArc,+2:NewArcMid
   ,+3:NewArcTipOnLargeArc,+4:OldLargeArcTip,+5:NewArcCentr
   ,+6:OldSmallArcMid,+7:OldLargeArcMid.
  ->k_rr:NewArcRadius
  */
/********************************/
