/*pltnonarc is used in plt** world.
  k_NONARC is used in k_** world.
*/
#include "pkt.h"

#define PLNLEN 100 /*1000isDemo,1200,2000   numb of vectors   pktr.h*/
short plpac;/*pktr.h*/
long plrx,plrx1,plrx2,plry,plry1,plry2;/*pktr.h*/
long pltrvp;/*pointer on pl1x[]   pktr.h*/
double far pl1x[PLNLEN];double far pl1y[PLNLEN];/*pktr.h*/
double far pl2x[PLNLEN];double far pl2y[PLNLEN];
double far pl3x[PLNLEN];double far pl3y[PLNLEN];
short pltmds24;/*pktr.h*/
#define PBLACK 0
#define PBLUE 1
#define PGREEN 2
#define PCYAN 3
#define PRED 4
#define PMAGENTA 5
#define PYELLOW 6
#define PWHITE 7

/*st is temporal working point in k_x[st], st3 is to k_x[st3+0 to =st3+2]
  st is st1.
  st12 takes 12points for temp from [st12]. So, [st12+12] is able in next
  operation.

PROBLEM:
 1.k_read(),k_ifgcbig():(long)x,y+0.5

*/
/**TEMPORAL**/
k_init()/*!! must locate in pkt1.c*/
{/*FundamentalParameter*/
   plrx=150;plry=80;plrx1=0;plry1=0;plrx2=0;plry2=0;
   k_exparad1=20.0;/*prolong() NumbOfProtrdDots MaxDxDyToSense*/
   k_exparas2=1;/*prolong() MaxNonExist*/
   k_exparas3=1;/*proc2vec()>ifprotrude() slev:gcbig_lev */
   k_exparas4=6;/*proc2vec()>ifprotrude() s_limDist */
   k_exparad5=0.1;/*proctype2() RightAngLimit*/
   k_exparad6=12.0;/* k_sense(...,this) MaxDxDy */
   k_exparas7=4;/* ifvecexist() MaxNonExistDots */
   k_exparas8=1;/* tryeval(..,this) ifgcbiglevl */
   k_exparad9=1.0;/* tryeval()>ifvecexist(,this,) dstep=StepSize */
   k_exparad10=2.0;/* 2vec()etc. TolToExcludeSameMidPoi */
   k_exparad11=2.0;/* ifk()  Veryshortvec is neglected. */
   k_exparad12=4.0;/* crs2linksto2arcs()>LimBtwnCrsAndLinkTip*/
   k_exparad13=1.0;/* ifk() NearLimToCrsPoi*/
   k_exparad14=2.0;
	 /* 2vec(),3vec()>arctan(),arcarcvalley(),linktandef() TransLen*/
   k_exparad15=100.0;/* 2vec(),3vec()>arctan(),arcarcvalley() NewArcLenLim*/
   k_exparas16=5;/* stp=(this) FIX.  InfSizeOf1NevCanddtVec*/
   k_exparad17=1.0;/* proc2vec()>ifonvecwide>WidenTolIn2CrsPointsCase*/

 k_pai=3.141592654;
 k_ontol=0.1;/*ifonlink() tolerance. provoke()*/
 k_lentol=0.001;/*means 0.0 for length*/
 k_cstol=0.001;/*means 0.0 for cos,sin value*/
 k_radtol=3.0;

 /*DataBaseInit*/
 k_funcstklvl=0;
 k_cleararea();k_clearcel();k_clearx();
 k_celgh=1;k_cellim=1;k_celonuse=0;/*duplcation with clearcel()*/
 k_xgh=1;k_xlim=1;k_xonuse=0;/*duplcation with clearx()*/

 /*AreaDivision*/
 k_tox=400.0;k_toy=500.0;/*!! (double)*/
 k_laxn=4;k_layn=5;/*setting !!*/
 k_arealim=k_laxn*k_layn;
 if(k_arealim>=k_AREAMAX){k_PRIERR(" err.TooManyAreaDivision");k_EXIT;}
 if(k_laxn==0||k_layn==0||k_tox==0.0||k_toy==0.0)
    {k_PRIERR(" err.TooManyAreaDivision");k_EXIT;}
 k_decx=k_tox/k_laxn;k_decy=k_toy/k_layn;

}
/**MustDeleteAtLast**/
/*
k_cleararea(){;}
k_POITY k_nextvec(a)k_POITY a;{;}
k_POITY k_nextcel(a)k_POITY a;{;}
k_clearcel(){;}
k_POITY k_nextx(a)k_POITY a;{;}
k_clearx(){;}
*/
/*********************************************************************/
double k_vecang(s) /*(ok)returns ang1000  (s as k_x,y[s to s+1])*/
short s;
{double dx,dy,d;
 dx=k_x[s+1]-k_x[s];dy=k_y[s+1]-k_y[s];
 if(dx==0.0){if(dy>0.0)d=250.0;else d=750.0;goto lend;}
 if(dy==0.0){if(dx>0.0)d=1.0;else d=500.0;goto lend;}
 d=atan2(dy,dx);
 d=d*499.0/3.1416;/*!!slow*/
 if(d<0.0)d+=999.0;
 d++;/*0 cut*/
lend:return(d);
}
/***/
k_rightpoint(sp,slink,sout)/*ok.RightPoint(k_x[sp]:point),k_x[slink]:link
		 ,k_x[sout]:out)*/
short sp,slink,sout;
{long l1;double x1,y1,x2,y2,dpix,dpiy,ddumy,dr,dr1,dr2,dr11,dr12;
 x1=k_x[slink];y1=k_y[slink];x2=k_x[slink+1];y2=k_y[slink+1];
 dpix=k_x[sp]-x1;dpiy=k_y[sp]-y1;x2-=x1;y2-=y1;
 if(x2==0.0&&y2==0.0){/*oret=1.0;*/k_x[sout]==x1;k_y[sout]==y1;return;}
 dr=(x2*dpix+y2*dpiy)/(x2*x2+y2*y2);
 k_x[sout]=x1+dr*x2;k_y[sout]=y1+dr*y2;
 /*oret=1.0;*/
 return;
}
/***/
long k_llcross(sl1,sl2,sout,st3)
/*ok.2lineCrossPoint(k_x[sl1]:link1=2Poi,k_x[sl2]:link2=2Poi,
       k_x[sout]:CrosPoi,st3:tempwork3k_x[st3+0,+1,+2])
       (sl1,sl2,sout1,st3)->Ret:1Cross0Para
!!yet.2links are on 1 line and has common part.*/
short sl1,sl2,sout,st3;
{long l1,l2,lgr;
 double dx,dy,d1,d2,d3,d4,d5,d;
 double x1,y1,x2,y2,x3,y3;
 x1=k_x[sl1];y1=k_y[sl1];
 k_x[st3]=x1;k_y[st3]=y1;
 k_rightpoint(st3,sl2,st3+1);x2=k_x[st3+1];y2=k_y[st3+1];
 k_rightpoint(st3+1,sl1,st3+2);x3=k_x[st3+2];y3=k_y[st3+2];
 if(x2==x3&&y2==y3){k_x[sout]=x2;k_y[sout]=y2;goto la;}/*NotComplete!!*/
 dx=x2-x1;dy=y2-y1;d1=dx*dx+dy*dy;
 dx=x3-x2;dy=y3-y2;d2=dx*dx+dy*dy;
 if(fabs(d1-d2)<=k_lentol){d3=0.0;}else{d=fabs(d1-d2);d3=sqrt(d);}/*!!*/
 /*if(d1==d2){d3=0.0;}else{d3=sqrt(d1-d2);}*/
 if(fabs(d3)<=k_lentol){lgr=0;goto lend;}
 d4=d2/d3;
 d5=d3+d4;d5=d5/d3;
 k_x[sout]=x1+(x3-x1)*d5;k_y[sout]=y1+(y3-y1)*d5;
la:lgr=1;
lend:return(lgr);
}
/***/
long k_cccross(sc1,sc2,sout2,st22)
 /*ok.CircCircCross Ret1:good,2:Near,0:NotCrs
		 <-k_radtol   ->st22+9(sc1Side),+19(sc2Side):ArcCentr
		 ->(double)k_rr1:RadiusSc1,k_rr2
		 (sc1:Arc3poi,sc2:Acr3Poi,sout2:2CrsPoi,st22:22temp)*/
short sc1,sc2,sout2,st22;
{long l;
 double d,da,d1,d2,dx1,dy1,dx2,dy2,dr1,dr2;

 l=k_arccentor(sc1,sc1+1,sc1+2,st22+9,st22);
   /*ArcCentor Ret:1:good,0NoCentor  ->st22+9(sc1Side),+19(sc2Side):ArcCentr
   (k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
 if(l==0){/*l=0;*/goto lend;}
 dr1=k_rr;k_rr1=k_rr;
 l=k_arccentor(sc2,sc2+1,sc2+2,st22+19,st22+10);
 if(l==0){/*l=0;*/goto lend;}
 dr2=k_rr;k_rr2=k_rr;

 d1=k_x[st22+9]-k_x[st22+19];d2=k_y[st22+9]-k_y[st22+19];
 d2=d1*d1+d2*d2;
 if(d2==0.0||d2==-0.0)/*doushinn_enn*/
  {l=0;goto lend;}
 d=sqrt(d2);
 if((dr1+dr2+k_radtol)>d&&d>(dr1+dr2))/*NearButNotContact*/
  {l=2;
   k_x[sout2]=(dr1/(dr1+dr2))*(k_x[st22+19]-k_x[st22+9])+k_x[st22+9];
   k_y[sout2]=(dr1/(dr1+dr2))*(k_y[st22+19]-k_y[st22+9])+k_y[st22+9];
   k_x[sout2+1]=k_x[sout2];k_y[sout2+1]=k_y[sout2];goto lend;}
 if(d>(dr1+dr2)){l=0;goto lend;}
 da=(d2-dr2*dr2+dr1*dr1)/(2.0*d);/*!!d==0.0case*/
 k_x[st22+20]=k_x[st22+9]+(k_x[st22+19]-k_x[st22+9])*(da/d);
 k_y[st22+20]=k_y[st22+9]+(k_y[st22+19]-k_y[st22+9])*(da/d);
 l=k_lccrossd(st22+9,st22+20,sout2,st22+21,dr1);
      /*ok.LineCircleCrossDirect Ret1:good,0No
       (CirCentr,CenRightpoiToLink,OutCross2Points,1Temp,ArcRadius) */
 /*l=l;*/
lend:return(l);
}
/***/
k_rot90(sobj,scen,sout)/*ok.Rotate90k_x[sobs]Arroundk_x[scen]ToOutk_x[sout]*/
short sobj,scen,sout;
{k_x[sout]=k_x[scen]+k_y[scen]-k_y[sobj];
 k_y[sout]=k_y[scen]+k_x[sobj]-k_x[scen];
 return;
}
/***/
long k_lccrossd(sc,sr,sout2,st1,dr)/*ok.LineCircleCrossDirect Ret1:good,0No
       (CirCentr,CenRightpoiToLink,OutCross2Points,1Temp,ArcRadius) */
short sc,sr,sout2,st1;double dr;
{double a,a2,d,d2,c,c2;long l;
 k_rot90(sc,sr,st1);/*Rotate90k_x[sobs]Arroundk_x[scen]ToOutk_x[sout]*/
 d=k_x[sr]-k_x[sc];d2=k_y[sr]-k_y[sc];
 d2=d2*d2+d*d;if(d2>(dr*dr)){l=0;goto lend;}else{l=1;}
 if(d2==0){l=0;goto lend;}/*not complete!!*/
 a2=dr*dr-d2;if(a2==0.0){a=0.0;}else{a=sqrt(a2);}
 c2=k_x[st1]-k_x[sr];d=k_y[st1]-k_y[sr];
 c2=c2*c2+d*d;if(c2==0.0){c=0.0;}else{c=sqrt(c2);}
 if(c==0.0){l=0;goto lend;}/*not complete!!*/
 c=a/c;
 k_x[sout2]=k_x[sr]+(k_x[st1]-k_x[sr])*c;
 k_y[sout2]=k_y[sr]+(k_y[st1]-k_y[sr])*c;
 k_x[sout2+1]=k_x[sr]-(k_x[st1]-k_x[sr])*c;
 k_y[sout2+1]=k_y[sr]-(k_y[st1]-k_y[sr])*c;
 l=1;
lend:return(l);
}
/***/
long k_lccross(slc1,slc2,sout2,st12)/*ok.LineArcCross2Points.
AtentnNot.k_lccrossd() Ret=1(cros),2(Near),0(NotCrs)
<-k_radtol:RadiusTolerance   ->k_rr:radius
(LineArcBy3Poi,LineArcBy3Poi,OutCros2poi(OnlyRet=1,2),12Temp)*/
short slc1,slc2,sout2,st12;
{long l;short s1,s2,s3;double d,dx,dy;
 s1=slc1;s2=slc2;
 if(k_x[s1+2]==(double)k_NONARC)/*s1 is link*/;else{s3=s1;s1=s2;s2=s3;}
 /*Here, s1 is link, s2 is arc.*/

 l=k_arccentor(s2,s2+1,s2+2,st12+9,st12);/*ok.ArcCentor Ret:1:good,0NoCentor
     (k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
 if(l==0){goto lend;}

 k_rightpoint(st12+9,s1,st12+10);/*ok.RightPoint(k_x[sp]:point)
      ,k_x[slink]:link,k_x[sout]:out)*/
 dx=k_x[st12+9]-k_x[st12+10];dx=dx*dx;dy=k_y[st12+9]-k_y[st12+10];dy=dy*dy;
 d=dx+dy;if(d!=0.0){d=sqrt(d);}

 if(d>k_rr&&((k_rr+k_radtol)>d))
  {l=2;k_x[sout2]=k_x[st12+10];k_y[sout2]=k_y[st12+10];
   k_x[sout2+1]=k_x[st12+10];k_y[sout2+1]=k_y[st12+10];goto lend;}

 l=k_lccrossd(st12+9,st12+10,sout2,st12+11,k_rr);/*ok.LineCircleCrossDirect
  Ret1:good,0No (CirCentr,CenRightpoiToLink,OutCross2Points,Temp,InputArcRadius)*/
 /*if(l==0)goto lend;*/
lend:slc1=s1;slc2=s2;
 return(l);
}
/***/
k_vertdiv2link(sp1,sp2,sout1,sout2,st)
      /*ok.VertDivLine(k_x[]link1,link2,out1,out2,tempwork)*/
short sp1,sp2,sout1,sout2,st;
{k_x[st]=(k_x[sp1]+k_x[sp2])/2.0;
 k_y[st]=(k_y[sp1]+k_y[sp2])/2.0;
 k_rot90(sp1,st,sout1);
 k_rot90(sp2,st,sout2);
 return;
}
/***/
long k_arccentor(sp1,sp2,spm,sout,st9)/*ok.ArcCentor Ret:1:good,0NoCentor
  (k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
short sp1,sp2,spm,sout,st9;
{double d1,d2;long l;
 if(k_x[spm]==k_NONARC){l=0;goto lend;}
 k_vertdiv2link(sp1,spm,st9,st9+1,st9+2);/*(sp1,sp2,sout1,sout2,st)*/
 k_vertdiv2link(spm,sp2,st9+3,st9+4,st9+5);
 l=k_llcross(st9,st9+3,sout,st9+6);
     /*2linkCrossPoint(k_x[sl1]:link1,k_x[sl2]:link2,
       k_x[sout]:CrosPoi st3:temporal3k_x[st3+0,+1,+2]   Ret:1Cross0Para*/
 if(l==0)goto lend;
 d1=k_x[sp1]-k_x[sout];d2=k_y[sp1]-k_y[sout];
 k_rr=d1*d1+d2*d2;if(k_rr!=0.0)k_rr=sqrt(k_rr);
 l=1;
lend:return(l);
}
/***/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/***/
long k_ifonarc(sa3,sp)/*ok.Ret1:PoiIsOnArc,0:No. (sa3:arc3poi,sp:point)
    Point=spMustOnTheCircle.  rf.k_ifonarc2()*/
short sa3,sp;
{long l;l=k_ifonarc2(sa3,k_x[sp],k_y[sp]);return(l);}
/***/
long k_ifonlink(sl2,sp)/*ok.Ret1:PoiIsOnLink,0:No. (sl2:link2poi,sp:point)
    Point=spMustOnTheLink.     rf.ifonlink2()
    <-k_ontol:tolerance  0 is bad for horizn/vert link*/
short sl2,sp;
{long l;l=k_ifonlink2(sl2,k_x[sp],k_y[sp]);return(l);}
/***/
k_arcdivpoi(sp1,sp2,sc,dratio,sout1)/*yet.test!! dratio<=0.0 dratio>=1.0*/
    /*ok.DivPoiByDratio(0.0-1.0isInter) Dire+ is sp1 to sp2. Out k_x[sout1]
    (tip1,tip2,centor,ratio,out)*/
short sp1,sp2,sc,sout1;
double dratio;
{short s2,s3;
 double dt,dr,dx,dy,dx1,dy1,dx2,dy2,dxc,dyc,ddt,ddx,ddy,c,s;
 dx1=k_x[sp1];dy1=k_y[sp1];
 dx2=k_x[sp2];dy2=k_y[sp2];
 dxc=k_x[sc];dyc=k_y[sc];
 dt=k_pltangl2d(dx1,dy1,dx2,dy2,dxc,dyc);
 ddt=dt*dratio;ddx=dx1-dxc;ddy=dy1-dyc;
 c=cos(ddt);s=sin(ddt);
 dx=dxc+ddx*c+ddy*s;dy=dyc-ddx*s+ddy*c;
 k_x[sout1]=dx;k_y[sout1]=dy;
}
/***/
double k_pltangl2d(dx1,dy1,dx2,dy2,dcx,dcy)
    /*ok.(dx1,dy1,dx2,dy2,dcx,dcy)
    Ret radianAngle 0.0 to +2*pai for ang<1-c-2 clockws is +.  always +.*/
double dx1,dy1,dx2,dy2;
double dcx,dcy;/*vec_num,center*/
{double d;
 d=plcos2d(dx1,dy1,dx2,dy2,dcx,dcy);if(d>1.0)d=1.0;if(d<-1.0)d=-1.0;
 d=acos(d);if(pltr2<0)return(2*k_pai-d);/*d is 0 to -pai*/
 return(d);/*d is 0 to pai*/
/*acos() returns 0 to pai.  math.h*/
}
/***/
double plcos2d(dx1,dy1,dx2,dy2,dcx,dcy)
   /*ok.RetCos (-1.0 to +1.0)
   pltr2:gaiseki(+:(Ang<1-c-2 is clockws and less than pai),
		 -:(Ang<1-c-2 is clockws and over pai)) */
double dx1,dy1,dx2,dy2;
double dcx,dcy;/*vec_num,center*/
{double x1,y1,x2,y2,a,b,c;
 x1=dx1-dcx;y1=dy1-dcy;
 x2=dx2-dcx;y2=dy2-dcy;
 a=x1*x1+y1*y1;if(a!=0.0)a=sqrt(a);
 b=x2*x2+y2*y2;if(b!=0.0)b=sqrt(b);
 c=x1*x2+y1*y2;a=a*b;if(a==0.0)return(0.0);
 a=c/a;
 /*sign*/
 b=x1*y2-y1*x2;b=-b;
	     /*pltr2=(short)b;?BadCast!!inCase b=+62400*/
	     pltr2=1;if(b<0.0)pltr2=-1;
 return(a);
}
/***/
k_regulatearc(sa3,st10)/*RegulateArcTipLocation. make tip1-mid-tip2 clockws
  <-->k_x[sa]:tip1,k_x[sa+1]:tip2,k_x[sa+2]:mid   (linkarc:k_x[sa3],10temp)
  ang<tip1-cen-mid and ang<mid-cen-tip2 must be less than pai.!!danger*/
short sa3,st10;
{long l;
 double d1,d2,x3,y3,x4,y4,x5,y5,xc,yc;
 if(k_x[sa3+2]==k_NONARC)goto lend;/*link*/
 x3=k_x[sa3];y3=k_y[sa3];x4=k_x[sa3+1];y4=k_y[sa3+1];/*2tips*/
 l=k_arccentor(sa3,sa3+1,sa3+2,st10+9,st10);/*if centor is gotten,use it!!*/
   /*ArcCentor Ret:1:good,0NoCentor
   (k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
 if(l==0){k_PRIWARN(" war.NonCentorArc.regulatearc()");goto lend;}
 x5=k_x[sa3+2];y5=k_y[sa3+2];/*mid point*/
 xc=k_x[st10+9];yc=k_y[st10+9];/*centor point*/
 d1=(x3-xc)*(y5-yc)-(y3-yc)*(x5-xc);
 d2=(x5-xc)*(y4-yc)-(y5-yc)*(x4-xc);
 if(d1>=0.0&&(d1*d2)>=0.0)goto lb;
 if(d1>=0.0&&(d1*d2)<0.0)goto lend;
 if(d1<0.0&&(d1*d2)>=0.0)goto lend;/*?not use!!*/
 if(d1<0.0&&(d1*d2)<0.0)goto lb;/*?not use!!*/

lb:/*exchange*/
 x5=k_x[sa3];k_x[sa3]=k_x[sa3+1];k_x[sa3+1]=x5;
 y5=k_y[sa3];k_y[sa3]=k_y[sa3+1];k_y[sa3+1]=y5;
lend:return;
}
/***/
double k_2poidist(sp1,sp2,sw)/*ok.RetDistanceBtwn2Points.
     (Poi1,Poi2,Switch(2:precise_power2,1:precise,0:approx))*/
short sp1,sp2,sw;
{double dx,dy,d;
 dx=k_x[sp1]-k_x[sp2];dy=k_y[sp1]-k_y[sp2];if(dx<0.0)dx=-dx;if(dy<0.0)dy=-dy;
 if(sw==0){d=dx+dy;goto lend;}
 if(sw==2){d=dx*dx+dy*dy;goto lend;}
 if(sw==1){d=dx*dx+dy*dy;if(d!=0.0)d=sqrt(d);}
lend:return(d);
}
/***/
double k_poilinkdist(sp,sl2,st1,sw)/*ok.RetDistanceBtwnPointLink.
  (Point,2LinkTips,1Temp,SwToEvalDist:0(aprx),1(sqrt),2(pow2))
  ->(short)k_sr1=sl2,sl2+1 or st1(NearestPoi)  <-k_ontol:tolerance*/
short sp,sl2,st1,sw;
{double d1,d2,d3,d;long l;
 d1=k_2poidist(sp,sl2,sw);
 d2=k_2poidist(sp,sl2+1,sw);
 k_rightpoint(sp,sl2,st1);/*RightPoint(k_x[sp]:point),k_x[slink]:link
		 ,k_x[sout]:out)*/
 l=k_ifonlink(sl2,st1);/*Ret1:PoiIsOnLink,0:No. (sl2:link2poi,sp:point)
    Point=spMustOnTheLink.*/
 if(l==1)/*OnLink*/{d3=k_2poidist(sp,st1,sw);}else{d3=k_BIGNUM;}
 d=d1;k_sr1=sl2;
 if(d2<d){d=d2;k_sr1=sl2+1;}
 if(d3<d){d=d3;k_sr1=st1;}
 return(d);
}
/***/
double k_lldist(sl1,sl2,st4,sw)/*ok.RetDistanceBtwnLinkLink.
	      (Link1,Link2,4Temp,SwToEvalDist:0(aprx),1(sqrt),2(pow2))
	      <-k_ontol:tolerance*/
short sl1,sl2,st4,sw;
{long l;double d1,d2,d3,d4,d;
 l=k_llcross(sl1,sl2,st4+3,st4);
     /*2lineCrossPoint(k_x[sl1]:link1=2Poi,k_x[sl2]:link2=2Poi,
       k_x[sout]:CrosPoi,st3:temporal3k_x[st3+0,+1,+2])   Ret:1Cross0Para*/
 if(l==0)goto la;
 l=k_ifonlink(sl1,st4+3);/*Ret1:PoiIsOnLink,0:No. (sl2:link2poi,sp:point)
    Point=spMustOnTheLink.*/
 if(l==0)goto la;
 l=k_ifonlink(sl2,st4+3);
 if(l==0)goto la;
 d=0.0;goto lend;/*crossed*/
la:
 d1=k_poilinkdist(sl1,sl2,st4,sw);
 d2=k_poilinkdist(sl1+1,sl2,st4,sw);
 d3=k_poilinkdist(sl2,sl1,st4,sw);
 d4=k_poilinkdist(sl2+1,sl1,st4,sw);
 /*double k_poilinkdist(sp,sl2,st1,sw) RetDistanceBtwnPointLink.
  (Point,2LinkTips,1Temp,SwToEvalDist:0(aprx),1(sqrt),2(pow2))
  ->(short)k_sr1=sl2,sl2+1 or st1(NearestPoi)*/
 d=d1;
 if(d2<d){d=d2;}
 if(d3<d){d=d3;}
 if(d4<d){d=d4;}
lend:return(d);
}
/***/
long k_linkrizearc(sa,soutn,st11)/*ok.MakeArcToLinks.
	     RetNumbOfLinks,0:NotArc,1:NotDiv
	     (Arc,Out:k_x[sout+0,1*3,2*3,..,(n-1)*3],11Temp)
	     if Ret=0or1,k_x[soutn] is vacant.
    ! Must to use regulated arc.
    if Ret=2 then k_x[soutn],k_x[(soutn+1)*3]. NextUse is from [soutn+3*Ret]*/
short sa,soutn,st11;
{long l;short sdiv,s,s3;double drad,d,dratio,dd;
 drad=1.2;/*!!drad: radian_angle<1c2 of piece arc.  !!rf.vvlist() a1[],a2[]*/
 l=k_arccentor(sa,sa+1,sa+2,st11+9,st11);/*use centor gotten before !!*/
   /*ArcCentor Ret:1:good,0NoCentor
   (k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
 if(l==0){l=0;goto lend;}
 d=k_pltangl2d(k_x[sa],k_y[sa],k_x[sa+1],k_y[sa+1],k_x[st11+9],k_y[st11+9]);
     /*(dx1,dy1,dx2,dy2,dcx,dcy)
     Ret radianAngle 0.0 to +2*pai for ang<1-c-2 clockws is +.  always +.*/
 sdiv=(short)(d/drad)+1;
 /*drad: rad_angle<1c2 of piece arc*/
 dratio=d/(((double)sdiv)*2.0);/*dratio is about half of drad.*/
 dratio=dratio/d;/*here dratio is ratio 0.0 to 1.0 */
 dd=dratio;
 if(sdiv<=1){l=1;goto lend;}
      /*k_arcdivpoi(point1,point2,centor,dratio,sout1)
      DivPoiByDratio(0.0-1.0isInter) Dire+ is sp1 to sp2. Out k_x[sout1]*/
   k_x[soutn]=k_x[sa];k_y[soutn]=k_y[sa];/*tip1*/
   s3=0;
 for(s=0;;)
  {k_arcdivpoi(sa,sa+1,st11+9,dd,st11+10);
   /*k_x[soutn+s3+2]=k_x[st11+10];arc.mid.ok*/
   k_x[soutn+s3+2]=k_NONARC;k_y[soutn+s3+2]=k_y[st11+10];/*mid*/
   dd+=dratio;
   k_arcdivpoi(sa,sa+1,st11+9,dd,st11+10);
   k_x[soutn+s3+1]=k_x[st11+10];k_y[soutn+s3+1]=k_y[st11+10];/*tip2*/
   s3+=3;s++;if(s>=sdiv)break;if((soutn+s3+3)>=k_TMPXMAX)goto la;
   k_x[soutn+s3]=k_x[st11+10];k_y[soutn+s3]=k_y[st11+10];/*tip1*/
   dd+=dratio;
  }

la:l=(long)sdiv;
lend:return(l);
}
/***/
double k_vvdist(sv1,sv2,st11m,sw)/*ok.RetDistBtwn2Vecs.
   ->(short)k_tmpxfront:k_x[front]   next use is from k_x[k_tmpxfront]
     ! Must to use regulated arc.
     Safe next Tmp is +71(=10linksInEachSideArc*3points*2bothSideVec+11)
     k_tmpfront=st11m+11+nTotalLinks(dividedFromArc)*3points;
     EX. k_vvdist(,,6,) TotalLinks are 6,then k_tmpfront=6+11+6*3=35;
	 k_x[35] is vacant.
     But TMP is TMP. Aft This Func ,can use Tmp. EX.k_x[6] can be used next.
   (Vec1By3Points,Vec2By3Points,11MoreTemp(till <k_tmpxfront)
    ,SwToEvalDist:0(aprx),1(sqrt),2(pow2))
   EX.k_regulatearc(0,6);k_regulatearc(3,6);
      d=k_vvdist(0,3,6,1);k_PRITES(" d=%f",d);*/
short sv1,sv2,st11m,sw;
{short a1[10],a2[10];/*!!Max10. rf.drad in linkrizearc()*/
 long l,l1,l2,lim1,lim2;double d,d0;short sl1,sl2,s2t;
 k_tmpxfront=st11m+11;
 if(k_x[sv1+2]==k_NONARC)/*link*/{lim1=1;a1[0]=sv1;l=0;}
  else/*arc*/
  {l=k_linkrizearc(sv1,st11m+11,st11m);
    /*long k_linkrizearc(sa,soutn,st11) MakeArcToLinks.
	     RetNumbOfLinks,0:NotArc,1:NotDiv
	     (Arc,Out:k_x[sout+0,1*3,2*3,..,(n-1)*3],11Temp)*/
   if(l<=1){lim1=1;a1[0]=sv1;}
    else{for(l1=0;l1<l&&l1<10;l1++){a1[l1]=st11m+11+l1*3;lim1=l;}}/*10!!*/
  }
 if(k_x[sv2+2]==k_NONARC)/*link*/
  {s2t=st11m+11+(short)l*3;lim2=1;a2[0]=sv2;l=0;}
  else/*arc*/
  {s2t=st11m+11+(short)l*3;
   l=k_linkrizearc(sv2,s2t,st11m);
   if(l<=1){lim2=1;a2[0]=sv2;}
    else{for(l2=0;l2<l&&l2<10;l2++){a2[l2]=s2t+l2*3;lim2=l;}}/*10!!*/
  }
 k_tmpxfront=s2t+l*3;/*TmpFront*/

 d=k_BIGNUM;
 for(l1=0;l1<lim1;l1++)
  {for(l2=0;l2<lim2;l2++)
    {sl1=a1[l1];sl2=a2[l2];/*k_PRITES(" sl1=%d",sl1);k_PRITES(" sl2=%d",sl2);*/
     d0=k_lldist(sl1,sl2,st11m,sw);    /*k_PRITES(" d0=%f",d0);*/
       /*double k_lldist(sl1,sl2,st4,sw)  ok.RetDistanceBtwnLinkLink.
	      (Link1,Link2,4Temp,SwToEvalDist:0(aprx),1(sqrt),2(pow2))
	      <-k_ontol:tolerance*/
     if(d0<d)d=d0;
    }
  }
 return(d);
}
/*****************************************************************/
double k_veclen(sv3,sw)/*ok.RetVecLength  LinkNeedNONARCat k_x[sv3+2]
    (VecBy3Points,Sw(2:precise_power2,1:precise,0:approx))
    !!NotFixedOnArc  rf.k_2poidist()*/
short sv3,sw;
{double d;
 if(k_x[sv3+2]!=k_NONARC)/*arc*/
  {d=k_2poidist(sv3,sv3+2,sw);d=d*2.0;}
 /*link*/
 else{d=k_2poidist(sv3,sv3+1,sw);}/*RetDistanceBtwn2Points.
     (Poi1,Poi2,Switch(2:precise_power2,1:precise,0:approx))*/
lend:return(d);
}
/***/
k_repveccen(sv3,sout,st10)/*ok.RepresentativeVecCentorAboutOnVec
  (Vec,Out1Point,10Temp)
  ! Arc Must regulated.
  !!slow on arc  !!algorthm is not fixed.*/
short sv3,sout,st10;
{double d,x,y;
 if(k_x[sv3+2]!=k_NONARC)/*arc!!*/
  {d=k_arccenang(sv3,st10);
   if(d<=1.57)/*short*/
    {k_x[sout]=(k_x[sv3]+k_x[sv3+1])/2.0;k_y[sout]=(k_y[sv3]+k_y[sv3+1])/2.0;goto lend;}
   if(d<4.64)/*warped MidPoiandTipPoi*/
    {k_x[sout]=(k_x[sv3+2]*2+k_x[sv3]+k_x[sv3+1])/4.0;
     k_y[sout]=(k_y[sv3+2]*2+k_y[sv3]+k_y[sv3+1])/4.0;goto lend;}
    else/*closed CentorPoi*/
    {k_x[sout]=k_x[st10+9];k_y[sout]=k_y[st10+9];goto lend;}
  }
  /*link*/
  else{k_x[sout]=(k_x[sv3]+k_x[sv3+1])/2.0;k_y[sout]=(k_y[sv3]+k_y[sv3+1])/2.0;}
lend:return;
}
/***/
double k_arccenang(sa3,st10)/*ok.Chuushinnkaku
    RetArcCentoralAngle(Arc,10Temp)
  ! MustUseRegulatedArc  !!slow
    Ret radianAngle 0.0 to +2*pai for ang<1-c-2 clockws is +.  always +.
    if NotArc or HaveNoCentor then Ret 0.0
    ! ->st10+9:centor*/
short sa3,st10;
{double d;long l;
 if(k_x[sa3+2]==k_NONARC){d=0.0;goto lend;}
 l=k_arccentor(sa3,sa3+1,sa3+2,st10+9,st10);
   /*long k_arccentor(short,short,short,short,short);
    ArcCentor Ret:1:good,0NoCentor
   (k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
 if(l==0){d=0.0;goto lend;}
 d=k_pltangl2d(k_x[sa3],k_y[sa3],k_x[sa3+1],k_y[sa3+1],k_x[st10+9],k_y[st10+9]);
 /*double k_pltangl2d(double,double,double,double,double,double);
    (dx1,dy1,dx2,dy2,dcx,dcy)
    Ret radianAngle 0.0 to +2*pai for ang<1-c-2 clockws is +.  always +.*/
lend:return(d);
}
/***/
long k_ifnearvecs(sv1,sv2,dtol,st11m)/*ok.Is2VecsNear. Ret1:Near,0:No.
	       (Vec1,Vec2,Tolerance,11moreTemp)*/
short sv1,sv2,st11m;double dtol;
{double x1c,y1c,d1,x2c,y2c,d2,ddx,ddy,d;long l;
 k_repveccen(sv1,st11m+10,st11m);x1c=k_x[st11m+10];y1c=k_y[st11m+10];
  /*ok.RepVecCentorAboutOnVec(Vec,Out1Point,10Temp)
  ! Arc Must regulated.
  !!slow on arc  !!algorthm is not fixed.*/
 k_repveccen(sv2,st11m+10,st11m);x2c=k_x[st11m+10];y2c=k_y[st11m+10];
 d1=k_veclen(sv1,0);d2=k_veclen(sv2,0);
    /*ok.RetVecLength  LinkNeedNONARCat[sv3+2]
    (VecBy3Points,Sw(2:precise_power2,1:precise,0:approx))
    !!NotFixedOnArc*/
 ddx=x1c-x2c;ddy=y1c-y2c;if(ddx<0.0)ddx=-ddx;if(ddy<0.0)ddy=-ddy;
 d=ddx+ddy;
 if((d1+d2+dtol)*1.8<d){l=0;goto lend;}
   /*else{l=1;goto lend;}*/

 /*not distant*/
    /*d=k_vvcross();will bad to set near vec. bcse need NEAR ones.*/
 d=k_vvdist(sv1,sv2,st11m,0);/*(vec,vec,tmp,sw)  !!slow*/
 if(d<=dtol)l=1;else l=0;
lend:return(l);
}
/***/
long k_vvcross(sv1,sv2,sout,st22,sw)
  /*ok.but.yet.VecVecCross. VecIsLinkOrCurve(=Arc).
  RetCrossPoiNum=2,1,0,WithSwitch.(vec,vec,Out2,Temp22
  ,Sw(1:OnVecCheck,0:NoCheck))
  ->k_x,y[sout or+1]=k_NONPOI(in sw==1&&CrsPoiIsNotOnVec&&(l.vs.c or c.vs.c))
  if 2 [sout,+]points are same(Ret=2), then tangential point.
!!yet.2links are on 1 line and has common part. llcross()problem
!!yet.in LinkArc when link goes through centor of arc.
!!yet.in ArcArc when Dupl Arc Pattern.
*/
short sv1,sv2,sout,st22,sw;
{short s;long l,lr;
 double d1,d2;
 d1=k_x[sv1+2];d2=k_x[sv2+2];
 if(d1==k_NONARC&&d2==k_NONARC)
  {l=k_llcross(sv1,sv2,sout,st22);
     /*2lineCrossPoint(k_x[sl1]:link1=2Poi,k_x[sl2]:link2=2Poi,
       k_x[sout]:CrosPoi,st3:temporal3k_x[st3+0,+1,+2])  Ret:1Cross0Para*/
   if(l==0){lr=0;goto lend;}
   if(sw==0){lr=1;goto lend;}
   if(k_ifonlink(sv1,sout)==1&&k_ifonlink(sv2,sout)==1){lr=1;goto lend;}
/*long k_ifonlink(short,short);Ret1:PoiIsOnLink,0:No. (sl2:link2poi,sp:point)
    Point=spMustOnTheLink.
    <-k_ontol:tolerance  0 is bad for horizn/vert link*/
   lr=0;goto lend;
  }
 if((d1!=k_NONARC&&d2==k_NONARC)||(d1==k_NONARC&&d2!=k_NONARC))
   {l=k_lccross(sv1,sv2,sout,st22);
   /*long k_lccross(short,short,short,short);LineArcCross2Points.
      AtentnNot.k_lccrossd() Ret=1(cros),2(Near),0(NotCrs)
      <-k_radtol:RadiusTolerance  ->k_rr:radius
     (LineArcBy3Poi,LineArcBy3Poi,OutCros2poi(OnlyRet=1,2),12Temp)*/
    if(l==0){lr=0;goto lend;}
    if(sw==0){lr=2;goto lend;}
    /*long k_ifonarc(short,short);Ret1:PoiIsOnArc,0:No.(sa3:arc3poi,sp:point)
	    Point=spMustOnTheCircle.*/
    lr=0;
    /*sout*/
    if(d1==k_NONARC)/*Link,Arc*/
     {if(k_ifonlink(sv1,sout)==1&&k_ifonarc(sv2,sout)==1){lr++;goto la;}}
     else/*Arc,Link*/
     {if(k_ifonarc(sv1,sout)==1&&k_ifonlink(sv2,sout)==1){lr++;goto la;}}
    k_x[sout]=k_NONPOI;k_y[sout]=k_NONPOI;
  la:
    /*sout+1*/
    if(d1==k_NONARC)/*Link,Arc*/
     {if(k_ifonlink(sv1,sout+1)==1&&k_ifonarc(sv2,sout+1)==1){lr++;goto lend;}}
     else/*Arc,Link*/
     {if(k_ifonarc(sv1,sout+1)==1&&k_ifonlink(sv2,sout+1)==1){lr++;goto lend;}}
    k_x[sout+1]=k_NONPOI;k_y[sout+1]=k_NONPOI;
    goto lend;
  }
 if(d1!=k_NONARC&&d2!=k_NONARC)
   {l=k_cccross(sv1,sv2,sout,st22);
      /*long k_cccross(short,short,short,short);
	   CircCircCross Ret1:good,2:Near,0:NotCrs
	   <-k_radtol
	   (sc1:Arc3poi,sc2:Acr3Poi,sout2:2CrsPoi,st22:22temp)*/
    if(l==0){lr=0;goto lend;}
    if(sw==0){lr=2;goto lend;}
    /*long k_ifonarc(short,short);Ret1:PoiIsOnArc,0:No.(sa3:arc3poi,sp:point)
	    Point=spMustOnTheCircle.*/
    lr=0;
    /*sout*/
    if(k_ifonarc(sv1,sout)==1&&k_ifonarc(sv2,sout)==1){lr++;goto lb;}
    k_x[sout]=k_NONPOI;k_y[sout]=k_NONPOI;
  lb:
    /*sout+1*/
    if(k_ifonarc(sv1,sout+1)==1&&k_ifonarc(sv2,sout+1)==1){lr++;goto lend;}
    k_x[sout+1]=k_NONPOI;k_y[sout+1]=k_NONPOI;
    goto lend;
  }
 lr=0;
lend:return(lr);
}
/*************/
long k_ifpointon2vecswide(sp,svec1,svec2,dtol)
 /*ok IsPointOnBoth2VecsWithStretchingDtolAt4Tips. (sp,svec1,svec2,dtol)
 Ret1:yes,0:no*/
short sp,svec1,svec2;double dtol;
{long l,lr;
 l=k_ifpointonvecwide(svec1,sp,dtol);
 if(l==0){lr=0;goto lend;}
 l=k_ifpointonvecwide(svec2,sp,dtol);
 if(l==0){lr=0;goto lend;}
 lr=1;
lend:return(lr);
}
/***/
long k_ifpointonvecwide(svec,sp,dtol)
 /*ok IsPointOnVecWithStretchingDtolAt2Tips. (svec,sp,dtol) Ret1:yes,0:no*/
short svec,sp;double dtol;
{double d;long l,lr;
 l=k_iflink(svec);
 if(l==1)
  {if(k_ifonlinkwide(svec,sp,dtol)==1){lr=1;goto lend;}}
  else
  {if(k_ifonarcwide(svec,sp,dtol)==1){lr=1;goto lend;}}
 lr=0;
lend:return(lr);
}
/***/
long k_ifonlinkwide(svec,sp,dtol)
 /*ok IsPointOnLinkWithStretchingDtolAt2Tips. PointMustOnLink.
 (svec,sp,dtol) Ret1:yes,0:no*/
short svec,sp;double dtol;
{long l,lr;double d;
 l=k_ifonlink(svec,sp);
 if(l==1){goto lyes;}
 d=k_2poidist(sp,svec,0);if(d<=dtol){goto lyes;}
 d=k_2poidist(sp,svec+1,0);if(d<=dtol){goto lyes;}
 lr=0;goto lend;
lyes:lr=1;
lend:return(lr);
}
/***/
long k_ifonarcwide(svec,sp,dtol)
 /*ok IsPointOnArcWithStretchingDtolAt2Tips. PointMustOnArc.
 (svec,sp,dtol) Ret1:yes,0:no*/
short svec,sp;double dtol;
{long l,lr;double d;
 l=k_ifonarc(svec,sp);
 if(l==1){goto lyes;}
 d=k_2poidist(sp,svec,0);if(d<=dtol){goto lyes;}
 d=k_2poidist(sp,svec+1,0);if(d<=dtol){goto lyes;}
 lr=0;goto lend;
lyes:lr=1;
lend:return(lr);
}
/***/
/***********/
long k_ifonlink2(sv,x,y)/*ok.Ret1:PoiIsOnLink,0:No.
    (sv:link2poi as k_x[sv,sv+1],(double)point_x,y)
    Point_x,y MustOnTheLink.
    <-k_ontol:tolerance  0 is bad for horizn/vert link*/
short sv;double x,y;
{long l;double x1,y1,x2,y2;
 x1=k_x[sv];y1=k_y[sv];x2=k_x[sv+1];y2=k_y[sv+1];
 if(
    ((x1-k_ontol<=x&&x<=x2+k_ontol)||(x2-k_ontol<=x&&x<=x1+k_ontol))
    &&
    ((y1-k_ontol<=y&&y<=y2+k_ontol)||(y2-k_ontol<=y&&y<=y1+k_ontol))
   )l=1;else l=0;
 return(l);
}
/***/
long k_ifonarc2(sa3,x,y)/*ok.Ret1:PoiIsOnArc,0:No. (sa3:arc3poi,sp:point)
    Point=spMustOnTheCircle.*/
short sa3;double x,y;
{long l;double x1,y1,x2,y2,d1,d2;
 x1=k_x[sa3+1]-k_x[sa3];y1=k_y[sa3+1]-k_y[sa3];
 x2=k_x[sa3+2]-k_x[sa3];y2=k_y[sa3+2]-k_y[sa3];
 d1=x1*y2-y1*x2;
 x2=x-k_x[sa3];y2=y-k_y[sa3];
 d2=x1*y2-y1*x2;
 d1=d1*d2;
 if(d1>=0.0)l=1;else l=0;
 return(l);
}
/************************/
/*******************************************************************/
/*******************************************************************/
/*** FACILITY A A A A A A ******************************************/
/*******************************************************************/
/*******************************************************************/
k_getnearpoi(sv1,sv2)
  /*ok.GetNearPoints(sv1:vec1 as k_x[sv1],sv2).
    ->k_sv1,2,3,4 as k_x[k_sv1.etc]  1,2:sv1_tips  3,4:sv2_tips  1,3:near_pair*/
short sv1,sv2;
{double d,dmin;short s;
 dmin=k_BIGNUM;
 d=k_2poidist(sv1,sv2,0);if(d<dmin){s=1;dmin=d;}
 d=k_2poidist(sv1+1,sv2,0);if(d<dmin){s=2;dmin=d;}
 d=k_2poidist(sv1,sv2+1,0);if(d<dmin){s=3;dmin=d;}
 d=k_2poidist(sv1+1,sv2+1,0);if(d<dmin){s=4;dmin=d;}
 if(s==1){k_sv1=sv1;k_sv2=sv1+1;k_sv3=sv2;k_sv4=sv2+1;}
 if(s==2){k_sv1=sv1+1;k_sv2=sv1;k_sv3=sv2;k_sv4=sv2+1;}
 if(s==3){k_sv1=sv1;k_sv2=sv1+1;k_sv3=sv2+1;k_sv4=sv2;}
 if(s==4){k_sv1=sv1+1;k_sv2=sv1;k_sv3=sv2+1;k_sv4=sv2;}
 return;
}
/***/
long k_div2arcfast(sp1,sp2,scen,dr,sout,st1)
  /*ok.DivideArcto2.(tip1 as k_x[this],tip2,cen,d_radius,sout,stmp1)
  NeedNotConcernTheOrderOf2Tips.
  ArcInnerAnglMustBe<pai
  RET 1:good,0:fail
  */
short sp1,sp2,scen,sout,st1;double dr;
{double d,dd;long l;
 k_x[st1]=(k_x[sp1]+k_x[sp2])/2.0;k_y[st1]=(k_y[sp1]+k_y[sp2])/2.0;
 d=k_2poidist(st1,scen,1);if(d<=k_lentol)goto lfail;
 dd=dr/d;
la:
 k_x[sout]=k_x[scen]+dd*(k_x[st1]-k_x[scen]);
 k_y[sout]=k_y[scen]+dd*(k_y[st1]-k_y[scen]);
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
short k_poineartip(sp1,sp2,spoi)
  /*ok.GetNearPoi(sp1,sp2,spoint) Ret=<sp1 or sp2>nearpoi. Ref:poidisttip()*/
short sp1,sp2,spoi;
{short s;double d1,d2;
 d1=k_2poidist(sp1,spoi,0);d2=k_2poidist(sp2,spoi,0);/*!!? sw=0*/
 if(d1<=d2)s=sp1;else s=sp2;return(s);
}
/***/
long k_getangmidby3poi(sp1,scen,sp2,sout)
  /*ok.GetDev2poiOfAng<sp1,scen,sp2. Ret1:good0:fail (sp1,scen,sp2,soutpoi)*/
short sp1,scen,sp2,sout;
{double dx1,dy1,dx2,dy2,d1,d2,d;long l;
 dx1=k_x[sp1]-k_x[scen];dy1=k_y[sp1]-k_y[scen];
 dx2=k_x[sp2]-k_x[scen];dy2=k_y[sp2]-k_y[scen];
 d1=sqrt(dx1*dx1+dy1*dy1);d2=sqrt(dx2*dx2+dy2*dy2);
 if(fabs(d1)<=k_lentol){l=0;goto lend;}
 if(fabs(d2)<=k_lentol){l=0;goto lend;}
 d=d1/d2;
 /*dx2=k_x[scen]+d*dx2;dy2=k_y[scen]+d*dy2;*/
 dx2=d*dx2;dy2=d*dy2;
 k_x[sout]=k_x[scen]+(dx1+dx2)/2.0;k_y[sout]=k_y[scen]+(dy1+dy2)/2.0;
 l=1;
lend:return(l);
}
/***/
double k_cosby3poi(sp1,scen,sp2)
  /*ok.Ret cos value by 3 poi.(sp1,scen,sp2) if(1vecLen==0)returns 1.0*/
short sp1,scen,sp2;
{double x1,y1,x2,y2,d,d2;
 x1=k_x[sp1]-k_x[scen];y1=k_y[sp1]-k_y[scen];
 x2=k_x[sp2]-k_x[scen];y2=k_y[sp2]-k_y[scen];
 d2=(x1*x1+y1*y1)*(x2*x2+y2*y2);if(d2==0.0||d2==-0.0){d=1.0;goto lend;}
 d=(x1*x2+y1*y2)/sqrt(d2);
lend:return(d);
}
/***/
long k_getinterarcbymidpoi(sv1,sv2,xmid,ymid,sout3,scrs,st5)
 /*ok.!!YET2vecIs0Len,2VecIsOn1Line,2VecHasCommonTip,MidPoiIsCrspoi.
 <-k_sv2,4 from k_getnearpoi() (sv1,sv2,xmid,ymid,sout3,scrs,st5)
 ->k_sv5,6:ArcLink,ArcArcConnectPoint.Ret:1:good,0:fail
 5 is on 1,2.  6 is on 3,4. 1,3 is near. 1,2 is vec. 3,4 is vec.
 ->k_rr:ArcRadius  ->k_x[st5+4]:ArcCentr
 sout3:sv1sideArcConnectPoi,sout3+1:sv2side,sout3+2:ArcJustMid*/
double xmid,ymid;short sv1,sv2,sout3,scrs,st5;
{double dcos,dsin,d,d2;long l;
 k_x[st5]=xmid;k_y[st5]=ymid;
 l=k_getangmidby3poi(k_sv2,scrs,k_sv4,st5+1);/*Ret 1:good 0:fail*/
 if(l==0)goto lend;
 k_x[st5+2]=k_x[scrs];k_y[st5+2]=k_y[scrs];
 k_rightpoint(st5,st5+1,st5+3);/*st:mid, st+1,+2:div2link, st+3:rightpoint*/
  /*ok.RightPoint(k_x[sp]:point),k_x[slink]:link,k_x[sout]:out)*/
      /*k_PRITES(" right=");k_showtmpx(st5+3,st5+3);*/
 k_sendpoi(st5+3,sout3+2);
 dcos=k_cosby3poi(k_sv2,scrs,st5+3);/*Ret cos value by 3 poi.(sp1,scen,sp2)*/
      /*k_PRITES(" dcos=%f",dcos);*/
 dsin=sqrt(1.0-dcos*dcos);
 d=k_2poidist(scrs,st5+3,1);d2=1.0-dsin;
      /*k_PRITES(" by.d=%f",d);k_PRITES(" d2=%f",d2);*/
 if(fabs(d2)<=k_cstol||fabs(d)<=k_lentol){l=0;goto lend;}
      /*k_PRITES(" by.d,d2!=0.0");*/
 k_rr=(d*dsin)/d2;/*r:arc radius*/  /*k_PRITES(" k_rr=%f",k_rr);*/
 d2=(d+k_rr)/d;
 k_x[st5+4]=k_x[scrs]+(k_x[st5+3]-k_x[scrs])*d2;/*st+4:ArcCentr*/
 k_y[st5+4]=k_y[scrs]+(k_y[st5+3]-k_y[scrs])*d2;
 k_rightpoint(st5+4,sv1,sout3);
 k_rightpoint(st5+4,sv2,sout3+1);
 k_sv5=sout3;k_sv6=sout3+1;
 l=1;
lend:return(l);
}
/**************************/
k_putoldvec(i,lv)
 /* (ok)sets candidates array.
 (i,lv)i:part_of_canddt,lv:vec_num */
short i;k_POITY lv;
{k_oldvecnum[i]=lv;k_oldvecnum[i+1]=-1;}
/***/
k_putnewvec(n,i,sv,sprio)
 /* (ok)sets candidates array.
 (n,i,sv,sprio)n:canddt_num,i:part_of_canddt,sv:vec1sttip,sprio:priority */
short n,i,sv,sprio;
{k_newvec[n][i]=sv;k_newvec[n][i+1]=-1;k_prio[n]=sprio;}
/***/
k_puttmp3x(s,sv1,sv2,sv3)/*(ok)k_x,y[s,+1,+2]=k_x,y[sv1,2,3];
     if s3=-1 NONARC*/
short s,sv1,sv2,sv3;
{k_x[s]=k_x[sv1];k_y[s]=k_y[sv1];
 k_x[s+1]=k_x[sv2];k_y[s+1]=k_y[sv2];
 if(sv3==-1)k_x[s+2]=k_NONARC;else k_x[s+2]=k_x[sv3];
 k_y[s+2]=k_y[sv3];
}
/***/
k_sendpoi(sfrom,sto)/*ok.send poi*/
short sfrom,sto;
{k_x[sto]=k_x[sfrom];k_y[sto]=k_y[sfrom];}
/***********************/
long k_sense(sp1,sp2,dmax)/*ok.sense from sp1 to sp2
 (sp1:tip1 as k_x[this],sp2:tip2,MaxDxDy(PosiValue))
 Ret 1:exist,0:no  <-k_ontol ->k_sns:HowManyEdges
 -> k_sx[k_sns],k_sy[k_sns]:Edges */
short sp1,sp2;double dmax;
{double x,y,x1,y1,x2,y2,dx,dy,ddx,ddy,d,dd,ddd,dm;short sud,s2;long l;
 k_sns=0;  /*k_PRITES(" dmax=%f",dmax);*/
 x1=k_x[sp1];y1=k_y[sp1];x2=k_x[sp2];y2=k_y[sp2];
 dx=x2-x1;dy=y2-y1;ddx=dx;ddy=dy;if(ddx<0.0)ddx=-ddx;if(ddy<0.0)ddy=-ddy;
 if(ddx<=k_ontol&&ddy<=k_ontol){goto lnonexist;}
 sud=0;/*down*/
 if(ddy>ddx)goto la;
 d=dy/dx;if(dx<0.0){ddd=-1.0;}else ddd=1.0;
 for(dd=0.0;fabs(dd)<=dmax;dd+=ddd)
  {x=x1+dd;y=y1+d*dd;s2=k_read((long)(x+0.5),(long)(y+0.5));
   if(sud==0&&s2==1/*#*/){k_sx[k_sns]=x;k_sy[k_sns]=y;sud=1;k_sns++;}
   if(sud==1&&s2==0/*#*/){k_sx[k_sns]=x;k_sy[k_sns]=y;sud=0;k_sns++;}
   if(k_sns>=k_SXMAX)goto lexist;
  }
 if(k_sns>=1)goto lexist;
 goto lnonexist;
la:
 d=dx/dy;if(dy<0.0){ddd=-1.0;}else ddd=1.0;
 for(dd=0.0;fabs(dd)<=dmax;dd+=ddd)
  {y=y1+dd;x=x1+d*dd;s2=k_read((long)(x+0.5),(long)(y+0.5));
   if(sud==0&&s2==1/*#*/){k_sx[k_sns]=x;k_sy[k_sns]=y;sud=1;k_sns++;}
   if(sud==1&&s2==0/*#*/){k_sx[k_sns]=x;k_sy[k_sns]=y;sud=0;k_sns++;}
   if(k_sns>=k_SXMAX)goto lexist;
  }
 if(k_sns>=1)goto lexist;
 goto lnonexist;

lnonexist:l=0;goto lend;
lexist:l=1;
lend:return(l);
}
/*******************************************************/
unsigned char k_read(lx,ly)/*!! Must put in pkmd.c*/
/*!! yet.  ReadDotFromEMS   Ret Pixel ((long)x,y)*/
long lx,ly;
{unsigned char uc;uc=plr((short)lx,(short)ly);
       k_PRITES(" x,y,uc=%d",lx);k_PRITES(",%d",ly);k_PRITES("[%d]",uc);
 return(uc);
}
/***/
short k_ifgcbig(lx,ly,slev)/*!! Must put in pkmd.c*/
long lx,ly;short slev;
{short s;
 s=(short)plr((short)lx,(short)ly);
       k_PRITES(" x,y,s=%d",lx);k_PRITES(",%d",ly);k_PRITES("[%d]",s);
 return(s);
}
/**vvvv******************************************************/
k_vecdisp()/*NoUseNow*/
{
 pl1x[1]=0.0;pl1y[1]=0.0;
 pl2x[1]=10.0;pl2y[1]=20.0;
 pl3x[1]=10000.0;
 /*k_1vecdisp(1);*//*#*/
 pltvecdisp(1,1);
}
/***/
k_1vecdisp(sv1,sv2,sv3)
  /*(sv1 as k_x[sv1]=tip1,sv2=tip2,sv3=mid)  ex.(1,2,3)(1,2,-1)(1,1,-1)
  if sv3==-1 disp link. if(sv1==sv2){pl2x[l]+=3.0;pl2y[l]+=3.0;}*/
short sv1,sv2,sv3;
{long l;l=pltrvp;
 if(pltrvp>=PLNLEN){k_PRIWARN(" ov.pltrvp.k_1vecdisp()");pltrvp--;}
 pl1x[l]=k_x[sv1];pl1y[l]=k_y[sv1]-1.0;
 pl2x[l]=k_x[sv2];pl2y[l]=k_y[sv2]-1.0;
 if(sv1==sv2){pl2x[l]+=3.0;pl2y[l]+=3.0;}
 if(sv3==-1){pl3x[l]=10000.0;goto la;}
 pl3x[l]=k_x[sv3];pl3y[l]=k_y[sv3]-1.0;
 if(pl3x[l]==k_NONARC)pl3x[l]=10000.0;/*!!10000.0*/
 /*# -1.0 is by BUG.*/
la:pltvecdisp(l,1);
}
/**********/
long k_iflinkexist(sp1,sp2,ddef,slim,slev)/*ok.IfLinkExist sp2 from sp1.
 (sp1:tip1 as k_x[this],sp2:tip2,d_StepDxDy,s_MaxNonExist,s_gcbig_lev)
 Ret 1:exist,0:no  ->add k_snoex:NonExistDegree(withLimit=slim) <-k_ontol*/
short sp1,sp2,slim,slev;double ddef;
{double x,y,x1,y1,x2,y2,dx,dy,ddx,ddy,d,dd,ddd,dm;short noex,s2;long l;
 x1=k_x[sp1];y1=k_y[sp1];x2=k_x[sp2];y2=k_y[sp2];
 dx=x2-x1;dy=y2-y1;ddx=dx;ddy=dy;if(ddx<0.0)ddx=-ddx;if(ddy<0.0)ddy=-ddy;
 if(ddx<=k_ontol&&ddy<=k_ontol){goto lexist;}
 noex=0;
 if(ddy>ddx)goto la;
 d=dy/dx;dm=fabs(dx);if(dx<0.0)ddd=-ddef;else ddd=ddef;
 for(dd=0.0;fabs(dd)<=dm;dd+=ddd)
  {x=x1+dd;y=y1+d*dd;s2=k_ifgcbig((long)(x+0.5),(long)(y+0.5),slev);
   if(s2==0)noex++;if(noex>=slim){l=0;goto lend;}}
 goto lexist;
la:
 d=dx/dy;dm=fabs(dy);if(dy<0.0)ddd=-ddef;else ddd=ddef;
 for(dd=0.0;fabs(dd)<=dm;dd+=ddd)
  {y=y1+dd;x=x1+d*dd;s2=k_ifgcbig((long)(x+0.5),(long)(y+0.5),slev);
   if(s2==0)noex++;if(noex>=slim){l=0;goto lend;}}
 /*goto lexist;*/
lexist:l=1;
lend:k_snoex+=noex;return(l);
}
/***/
k_prolong(sp1,sp2,sout,dlim,slim,slev)/*ok.Prolong sp2 direfrom sp1.
 ->sout as k_x[sout]:NewTipPoi   DxDyStep is 1.
 (sp1:fromoffrom,sp2:justfrom,newtip_out,MaxDxDy,MaxNonExist,gcbig_levl)
 (?)BetterToReformAlgrthmTheCaseOf(slim>=2)
 Ifever sp2 is vacant, ans is sp2.
 */
short sp1,sp2,slim;double dlim;
{double x,y,x1,y1,x2,y2,dx,dy,ddx,ddy,d,dd,ddd,dm;short noex,s2;
 x1=k_x[sp1];y1=k_y[sp1];x2=k_x[sp2];y2=k_y[sp2];
 dx=x2-x1;dy=y2-y1;ddx=dx;ddy=dy;if(ddx<0.0)ddx=-ddx;if(ddy<0.0)ddy=-ddy;
 k_x[sout]=x2;k_y[sout]=y2;
 if(ddx<=k_ontol&&ddy<=k_ontol){goto lnon;}
 noex=0;
 if(ddy>ddx)goto la;
 d=dy/dx;dm=fabs(dx);if(dx<0.0)ddd=-1.0;else ddd=1.0;
 for(dd=0.0;fabs(dd)<=dlim;dd+=ddd)
  {x=x2+dd;y=y2+d*dd;s2=k_ifgcbig((long)(x+0.5),(long)(y+0.5),slev);
   if(s2==0)noex++;if(noex>=slim){goto lend;}
   k_x[sout]=x;k_y[sout]=y;}
 goto lend;
la:
 d=dx/dy;dm=fabs(dy);if(dy<0.0)ddd=-1.0;else ddd=1.0;
 for(dd=0.0;fabs(dd)<=dlim;dd+=ddd)
  {y=y2+dd;x=x2+d*dd;s2=k_ifgcbig((long)(x+0.5),(long)(y+0.5),slev);
   if(s2==0)noex++;if(noex>=slim){goto lend;}
   k_x[sout]=x;k_y[sout]=y;}
 goto lend;
lnon:k_x[sout]=x2;k_y[sout]=y2;
lend:return;
}
/***/
long k_ifarcexist(sp1,sp2,scen,dr,dstep,st3,slim,slev)
  /*ok.Ret 1:exist,0:no
  (stip1,stip2,scentr,dradius,dstep,stmp3,slim:MaxNonExist,slev:gcbig_lev)*/
short sp1,sp2,scen,st3,slim,slev;double dr,dstep;
{long l;
 l=k_div2arcfast(sp1,sp2,scen,dr,st3+1,st3);if(l==0)goto lnon;
  l=k_div2arcfast(sp1,st3+1,scen,dr,st3+2,st3);if(l==0)goto lnon;
   l=k_iflinkexist(sp1,st3+2,dstep,slim,slev);if(l==0){goto lnon;}
    /*(sp1:tip1 as k_x[this],sp2:tip2,StepDxDy,MaxNonExist,gcbig_lev)*/
   l=k_iflinkexist(st3+2,st3+1,dstep,slim,slev);if(l==0){goto lnon;}
  l=k_div2arcfast(st3+1,sp2,scen,dr,st3+2,st3);if(l==0)goto lnon;
   l=k_iflinkexist(st3+1,st3+2,dstep,slim,slev);if(l==0){goto lnon;}
   l=k_iflinkexist(st3+2,sp2,dstep,slim,slev);if(l==0){goto lnon;}
 l=1;
 goto lend;
lnon:l=0;
lend:return(l);
}
/***/
long k_ifvecexist(sp1,sp2,smid,scen,dr,dstep,st3,slim,slev)
 /*ok.Ret 1:exist,0:no  ->add k_snoex:NonExistDegree
 (stip1,stip2,smid:RefOnlyNONARC,scentr,dradius,dstep,stmp3
  ,slim:MaxNonExist;slev:gcbig_lev)*/
short sp1,sp2,scen,st3,slim,slev;double dr,dstep;
{long l;
 if(k_x[smid]!=k_NONARC)l=k_ifarcexist(sp1,sp2,scen,dr,dstep,st3,slim,slev);
  else l=k_iflinkexist(sp1,sp2,dstep,slim,slev);
 return(l);
}
/***/
long k_ifprotrude(sv,scrs,st,slev,sprolev)/*ok.IfVecProtrudesCrospoi
 (s_vec,s_crospoi,stmp1,slev:gcbig_lev,s_limDist) Ret 1:yes,0:no*/
short sv,scrs,st,slev,sprolev;
{short s,s2;double d;long l;
 s=k_poineartip(sv,sv+1,scrs);if(s==sv)s2=sv+1;else s2=sv;
 /*k_prolong(s2,scrs,st,20,1,slev);*/
 k_prolong(s2,scrs,st,k_exparad1,k_exparas2,slev);
 /*(sp1:fromoffrom,sp2:justfrom,newtip_out,MaxDxDy,MaxNonExist,gcbig_levl)*/
 d=k_2poidist(st,scrs,0);
 if((short)d>sprolev)l=1;else l=0;
 return(l);
}
/*********************************/
long k_proc2vec(lv1,lv2,sv1,sv2,st_n)/*ok.process for 2vecs intersection.
   Ret 1:processed,0:no (lv1,lv2,sv1,sv2,stmp_n)*/
k_POITY lv1,lv2;short sv1,sv2,st_n;
{long l,l1,l2;
 l=k_vvcross(sv1,sv2,st_n+22,st_n,0);
  /*ok.but.yet.VecVecCross. VecIsLinkOrCurve(=Arc).
  RetCrossPoiNum=2,1,0,WithSwitch.(vec,vec,Out,Temp22
  ,Sw(1:OnVecCheck,0:NoCheck))*/
     /*k_showtmpx(st_n+22,st_n+22);k_PRITES(" 0l=%d",l);*/
 if(l==0){l=0;k_PRITES(" proc2.2crss");getchar();goto lend;}
 if(l==2)
  {l1=k_ifpointon2vecswide(st_n+22,sv1,sv2,k_exparad17);
    /*ok IsPointOnBoth2VecsWithStretchingDtolAt4Tips. (sp,svec1,svec2,dtol)
     Ret1:yes,0:no*/
   if(l1==1)goto la;
   l2=k_ifpointon2vecswide(st_n+23,sv1,sv2,k_exparad17);
   if(l2==1){k_sendpoi(st_n+23,st_n+22);goto la;}
   /*if(l1==0&&l2==0)*/{l=0;goto lend;}
  }
  /*!!Yet. touch but some distant case (l=2)*/
la:
 l1=k_ifprotrude(sv1,st_n+22,st_n+23,k_exparas3,k_exparas4);/*(...,1,6)*/
 l2=k_ifprotrude(sv2,st_n+22,st_n+24,k_exparas3,k_exparas4);
   /*(s_vec,s_crospoi,stmp1,slev:gcbig_lev,s_limDist) Ret 1:yes,0:no*/
     k_showtmpx(st_n+22,st_n+22);k_PRITES(" proc2vec.l1=%d",l1);k_PRITES(" l2=%d",l2);
 l=0;
 if(l1==0&&l2==0){k_proctype=2;}
 if(l1==1&&l2==1){k_proctype=4;}
 if(l1==1&&l2==0){k_proctype=3;}
 if(l1==0&&l2==1){k_proctype=3;}
 if(k_proctype==4){k_4vec(lv1,lv2,sv1,sv2,st_n+22,st_n+23);}
 if(k_proctype==3&&l1==0)/*lv2:protrude*/
  {k_3vec(lv2,lv1,sv2,sv1,st_n+22,st_n+23);}
 if(k_proctype==3&&l1==1)/*lv1:protrude*/
  {k_3vec(lv1,lv2,sv1,sv2,st_n+22,st_n+23);}
 if(k_proctype==2)
  {l=k_proctype2(lv1,lv2,sv1,sv2,st_n+22,st_n+23);}
lend:return(l);
}
/***/
long k_proctype2(lv1,lv2,sv1,sv2,scrs,st_n)
  /*ok.ProcessType2(lv1,lv2,sv1,sv2,scrs,st_n) Ret?!!*/
short sv1,sv2,st_n;k_POITY lv1,lv2;
{double dcos,dlim;long l;
 l=0;dlim=k_exparad5;
 k_getnearpoi(sv1,sv2);
  /*->k_sv1,2,3,4 as k_x[k_sv1.etc]  1,2:sv1_tips  3,4:sv2_tips  1,3:near_pair*/
 dcos=k_cosby3poi(k_sv2,scrs,k_sv4);
 if(dcos>dlim){k_2vecang=k_SHARP;}
 if((-dlim)<=dcos&&dcos<=dlim){k_2vecang=k_RIGHT;}
 if(dcos<(-dlim)){k_2vecang=k_BLUNT;}
 k_2vec(lv1,lv2,sv1,sv2,scrs,st_n);
		/*<-k_sv1,2,3,4 if(proctype==3){lv1:protrude}*/
 return(l);
}
/*********************************************/
k_tryeval(snlim,st_n,slev)/*(ok)TryEval(NumbOfCandidates,stmp,slev:gcbig_levl)
  <-k_newvec[][],k_oldvec[][],prio[] (snlim,st_n,slev)
  NewVec k_x[]points must be located sequentially adjacently from sv.*/
short snlim,st_n,slev;
{short n,s,snum,sv,i,snonexist,snold;long l,leval,lpmax,ll;k_POITY lv;
	 k_PRITES(" try.snlim=%d",snlim);
 lpmax=0;  ll=-1;/*FitCanddt*/
 for(n=0;n<snlim;n++)/*foreach candidate*/
  {leval=0;k_snoex=0;/*DegreeOfNonExist*/snum=0;/*NumbOfVecsIn1Canddt*/
   for(s=0;k_newvec[n][s]!=-1;s++)/*part_vec in canddt*/
    {sv=k_newvec[n][s];
		   l=k_arccentor(sv,sv+1,sv+2,st_n+9,st_n);/*# must get scen,dr*/
	  /*ArcCentor Ret:1:good,0NoCentor
      (k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
     snum++;     k_PRITES(" sv=%d",sv);
     snold=k_snoex;
     l=k_ifvecexist(sv,sv+1,sv+2,st_n+9,k_rr,k_exparad9/*1.0*/,st_n+10,k_exparas7/*4*/,slev);/*# 2.0,1*/
      /*(sp1,sp2,smid,scen,dr,dstep,st3,slim,slev)
       (stip1,stip2,smid:RefOnlyNONARC,scentr,dradius,dstep,stmp3
	,slim:MaxNonExist;slev:gcbig_lev)*/    /*l=0;test*/
     snonexist=k_snoex-snold;
     if(l==0)snonexist=20;/*!! 20*/
     leval+=(long)(20-snonexist);/*!! 20*/
    }
   if(snum==0){leval=0;goto lnexcand;}
   leval=leval/snum;
   leval=leval*k_prio[n];               k_PRITES(" leval=%d",leval);
   if(leval>lpmax){ll=(long)n;lpmax=leval;}
  lnexcand:;
  }
    k_PRITES(" lpmax=%d",lpmax);
 if(lpmax==0)goto lend;/*NotExistAnyCandidts*/

 /*!!YET. put vec l, del vec*/
 n=ll;
 for(i=0;k_newvec[n][i]!=-1;i++)
  {sv=k_newvec[n][i];    k_PRITES(" sv=%d",sv);
	  pltmds24=PMAGENTA;k_1vecdisp(sv,sv+1,sv+2);pltmds24=PCYAN;
   /*l=k_putvect(k_x[sv],k_y[sv],k_x[sv+1],k_y[sv+1],k_x[sv+2],k_y[sv+2],st_n,1);*/
  /*ok.PutVecTotal(6xy,17TMP,sw).
   sw=1:regCenRadiusLenAngReglateArc,0:no   RetGeoNum,0:fail*/
  }
 for(i=0;k_oldvecnum[i]!=-1;i++)
  {lv=k_oldvecnum[i];    k_PRITES(" lv=%d",lv);
   /*l=k_delvec(lv);*/
      /*ok.Del1VecAllInf(VecNum(Not1befor)) Ret1:Suc,0Fail*/
  }
lend:return(l);
}
/**bbbb**/
k_2vec(lv1,lv2,sv1,sv2,scrs,st_n)
   /*ok.<-k_sv1,2,3,4 from k_getnearpoi() by proctype2()
      (VecNum1,VecNum2,svec1,svec2,crospoi,stmp_n)*/
short sv1,sv2,scrs,st_n;k_POITY lv1,lv2;
{short sn,snlim,j,smid,stp,stp2,stp3,stp4,sj,si,siout,s,sk,sk2,smodinvt;
 long l;double xmid,ymid,xold,yold,d;
   k_PRITES(" 2vec.");getchar();
 stp=k_exparas16;
 stp2=stp+stp;stp3=stp2+stp;stp4=stp3+stp;
 k_putoldvec(0,lv1);k_putoldvec(1,lv2);

 /*2link pair. so snlim=1 afterward.*/
 k_mknewvec(0,0,st_n,1,k_sv2,scrs,sv1+2);
 k_mknewvec(0,1,st_n+stp,1,k_sv4,scrs,sv2+2);
 xold=k_x[scrs];yold=k_y[scrs];
				 k_showtmpx(st_n,st_n+2);
				 k_showtmpx(st_n+stp,st_n+stp+2);
 sj=st_n+stp2;

 l=k_getangmidby3poi(k_sv2,scrs,k_sv4,sj);
	/*Ret 1:good 0:fail(sp1,scen,sp2,soutpoi)*/
 if(l==0){snlim=1;j=stp2;goto ln;}
			 k_PRITES(" midby3=");k_showtmpx(sj,sj);
 l=k_sense(scrs,sj,k_exparad6);/*sense from sp1 to sp2
    (sp1:tip1 as k_x[this],sp2:tip2,MaxDxDy) ->k_sns*/
 if(l==0){snlim=1;j=stp2;goto ln;}
			 k_showsx();
	/*# must exclude sensed poi is crspoi.*/
 j=stp2;snlim=1;/*NumbOfCanddts*/ sn=0;/*sensed array pointer*/
	     /*k_PRITES(" 2vec:st_n+j=%d",st_n+j);getchar();*/
 for(;;)/*foreach sensed point*/
  {xmid=k_sx[sn];ymid=k_sy[sn];
   if(fabs(xold-xmid)<k_exparad10&&fabs(yold-ymid)<k_exparad10)goto lb;
   xold=xmid;yold=ymid;
   /*R   ok*/
   if(k_proctype!=2)goto lc;
   if(k_x[sv1+2]!=k_NONARC||k_x[sv2+2]!=k_NONARC)goto lc;/*Not(BothAreLink)*/
   l=k_getinterarcbymidpoi(sv1,sv2,xmid,ymid,st_n+j+stp3,scrs,st_n+j+stp3+3);
	 /*<-k_sv1,2,3,4 ->k_sv5,6 (sv1,sv2,xmid,ymid,sout3,scrs,st5)(xmid,ymid,crospoi,stmp)*/
   if(l==0)goto lc;
   sj=st_n+j+stp3+3;
   k_x[sj]=xmid;k_y[sj]=ymid;
   k_mknewvec(snlim,0,st_n+j,1,k_sv5,k_sv6,sj);
   k_mknewvec(snlim,1,st_n+j+stp,1,k_sv2,k_sv5,sv1+2);
   k_mknewvec(snlim,2,st_n+j+stp2,1,k_sv4,k_sv6,sv2+2);

			/*!! MustAlter scrs to sv1+2,sv2+2 midPoi*/
		       k_PRITES("NewArc=");k_showtmpx(st_n+j,st_n+j+2);
				 k_showtmpx(st_n+j+stp,st_n+j+stp+2);
				 k_showtmpx(st_n+j+stp2,st_n+j+stp2+2);
   j+=stp3;snlim++;
  lc:/*mentori  ok*/
   if(k_proctype!=2)goto lb;
   if(k_x[sv1+2]!=k_NONARC||k_x[sv2+2]!=k_NONARC)goto lb;/*Not(BothAreLink)*/
   if(k_2vecang==k_BLUNT)goto lb;
   si=st_n+j+stp3;k_x[si]=xmid;k_y[si]=ymid;siout=si+1;
   l=k_fillet(sv1,sv2,si,si+1,si+3);
       /*(link1,link2,MentoriPoi,OutMentori2Tips,stmp10)*/
   if(l==0)goto lb;
   k_mknewvec(snlim,0,st_n+j,1,siout,siout+1,-1);
   k_mknewvec(snlim,1,st_n+j+stp,1,k_sv2,siout,-1);
   k_mknewvec(snlim,2,st_n+j+stp2,1,k_sv4,siout+1,-1);
   j+=stp3;snlim++;
  lb:sn++;/*next sensed point*/
   if((st_n+j+stp3+25/*!!+25*/)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.2vec()");goto la;}
   if(sn>=k_sns||sn>=k_SXMAX)break;
  }

ln:    /*k_PRITES(" 2vec.ln:st_n+j=%d",st_n+j);getchar();*/
  {/*linktandef  ok*/
   if(k_x[sv1+2]!=k_NONARC||k_x[sv2+2]!=k_NONARC)goto lbltd;/*Not(BothAreLink)*/
   sj=st_n+j+stp3;/*sout*/k_rot90(k_sv4,k_sv3,sj+4);k_rot90(sj+4,k_sv3,sj+5);
   l=k_linktandef(sv1,sv2,k_exparad14,sj+5,sj,sj+6);
  /*ok.stl is translated ddef to sl. It and sl cross poi is NewArcTip.
  (sl:link,stl:TanLink,ddef,stp:ArcSideOnStl,sout4,st8)
  Arc is generated to stp existing side.
  stp must not be at crspoi btwn sl,stl.  RET 1:good,0:fail
  Arc can be 2. But stp side arc is generated.
  ->sout4:NewArcTipPoiOnStl,sout4+1:NewArcMid,sout4+2:NewAcrCen
    ,sout4+3:NewArcTipOnSl.
  NewArc:sout4+3,sout4,sout4+1(mid)
  ->k_rr:NewArcRadius
  Attention:NotChangeSl,Stl.
  */
   if(l==0)goto lbltd;
   sk=k_poidisttip(sv1,sv1+1,sj);
   sk2=k_poidisttip(sv2,sv2+1,sj);
   k_mknewvec(snlim,0,st_n+j,1,sj+3,sj,sj+1);/*NewArc*/
   k_mknewvec(snlim,1,st_n+j+stp,1,sk,sj+3,sv1+2);/*OldLink*/
   k_mknewvec(snlim,2,st_n+j+stp2,1,sk2,sj,sv2+2);/*TanLink*/
			/*!! MustAlter scrs to sv1+2,sv2+2 midPoi*/
		       k_PRITES("NewArc=");k_showtmpx(st_n+j,st_n+j+2);
				 k_showtmpx(st_n+j+stp,st_n+j+stp+2);
				 k_showtmpx(st_n+j+stp2,st_n+j+stp2+2);
   j+=stp3;snlim++;
  lbltd:
   if((st_n+j+stp3+25/*!!+25*/)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.2vec()");goto la;}
  }

  {/*linktandef  ok*/
   if(k_x[sv1+2]!=k_NONARC||k_x[sv2+2]!=k_NONARC)goto lbltd2;/*Not(BothAreLink)*/
   sj=st_n+j+stp3;/*sout*/k_rot90(k_sv2,k_sv1,sj+4);k_rot90(sj+4,k_sv1,sj+5);
   l=k_linktandef(sv2,sv1,k_exparad14,sj+5,sj,sj+6);
   if(l==0)goto lbltd2;
   sk=k_poidisttip(sv1,sv1+1,sj);
   sk2=k_poidisttip(sv2,sv2+1,sj);
   k_mknewvec(snlim,0,st_n+j,1,sj+3,sj,sj+1);/*NewArc*/
   k_mknewvec(snlim,1,st_n+j+stp,1,sk2,sj+3,sv2+2);/*OldLink*/
   k_mknewvec(snlim,2,st_n+j+stp2,1,sk,sj,sv1+2);/*TanLink*/
			/*!! MustAlter scrs to sv1+2,sv2+2 midPoi*/
		       k_PRITES("NewArc=");k_showtmpx(st_n+j,st_n+j+2);
				 k_showtmpx(st_n+j+stp,st_n+j+stp+2);
				 k_showtmpx(st_n+j+stp2,st_n+j+stp2+2);
   j+=stp3;snlim++;
  lbltd2:
   if((st_n+j+stp3+25/*!!+25*/)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.2vec()");goto la;}
  }

ln2:     /*k_PRITES(" 2vec.ln2:st_n+j=%d",st_n+j);getchar();*/
  {/*arctan ok*/smodinvt=0;
   if(k_iflink(sv1)==1&&k_iflink(sv2)==1)goto lbat;
   if(k_iflink(sv1)==0&&k_iflink(sv2)==0)goto lbat;
   if(k_iflink(sv1)==0){smodinvt=1;l=lv1;lv1=lv2;lv2=l;s=sv1;sv1=sv2;sv2=s;}
   /*Now sv1:Link,sv2:arc.  NotExchanged=k_vs1,2,3,4:NotUse*/
   sj=st_n+j+stp3;/*WorkArea*/
   l=k_arccentor(sv2,sv2+1,sv2+2,sj,sj+1);/*!!Slow. MustGetFrom lv2*/
   /*(k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
   if(l==0)goto ln3;
   d=k_rr;
   l=k_arctan(sv2,sv1,sj,d,k_exparad14,k_exparad15,sj+1,sj+5);
			/*Attention exparad15*/
     /*(sa,stl,sc,dr,ddef,dlim,sout4,st12)
 sout4:TipBtwnOldArcAndNewArc,sout4+1:NewArcTip=TanPoi,sout4+2:NewArcMid
 sout4+3:NewArcCentr
     sj:OldArcCen,sj+1:TipBtwnOldArcAndNewArc,sj+2:TanPoi,sj+3:NewArcMid
     sj+4:NewArcCen,  sj+5:OldArcNewMid sk:OldArcDistTip*/
   if(l==0)goto lbat;
   sk2=k_poidisttip(sv2,sv2+1,sj+2);/*OldArc*/
   sk=k_poidisttip(sv1,sv1+1,sj+2);/*TanLink*/
   l=k_div2arcfast(sk2,sj+1,sj,d,sj+5,sj+6);if(l==0)goto ln3;
  /*ok.DivideArcto2.(tip1 as k_x[this],tip2,cen,d_radius,sout,stmp1)*/
   k_mknewvec(snlim,0,st_n+j,1,sj+1,sj+2,sj+3);/*NewArc*/
		 /*pltmds24=PYELLOW;k_1vecdisp(sj+1,sj+2,sj+3);getchar();*/
   k_mknewvec(snlim,1,st_n+j+stp,1,sk,sj+2,sv1+2);/*Link*/
		 /*k_1vecdisp(sk,sj+2,sv1+2);getchar();*/
   k_mknewvec(snlim,2,st_n+j+stp2,1,sk2,sj+1,sj+5);/*OldArc*/
		 /*k_1vecdisp(sk2,sj+1,sj+5);getchar();pltmds24=PCYAN;*/

			/*!! MustAlter scrs to sv1+2,sv2+2 midPoi*/
   if(smodinvt==1){l=lv1;lv1=lv2;lv2=l;s=sv1;sv1=sv2;sv2=s;smodinvt=0;}
   j+=stp3;snlim++;
  lbat:
   if((st_n+j+stp4+25/*!!+25*/)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.2vec()");goto la;}
  }

ln3:  k_PRITES(" 2vec.ln3:st_n+j=%d",st_n+j);getchar();
  {/*arcarcvalley  ok*/
   if(k_iflink(sv1)==1||k_iflink(sv2)==1)goto ltry;
	    /*!!NeedMoreCheck(CrsIsBtwn2Centrs)*/
   if((st_n+j+stp4+50)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.2vec()");goto la;}
   /*BothAreArcs*/
   sj=st_n+j+stp4;
   l=k_arcarcvalley(sv1,sv2,k_exparad14,k_exparad15,sj,sj+13);
				  /*!!?SlowForGettingCen*/
    /*ok.Case there are 2Arcs as a valley. 2NewTangentialArcs are generated.
    (sa1,sa2,ddef=TransltDifFromTanLine,dlim=NewArcLenthLim,sout13,st36)
    RET1:good,0:fail
    sa1,sa2:Arc3Poi(2Tips,1Mid)
    <-k_radtol:if this is small, arc cross is not found.
    ->SA1_SIDE  ARC:sout13,+1,+2(=mid)
  sout13:NewOldArcTip,sout13+1:NewArcTanTip,sout13+2:NewArcMid,sout13+3:NewArcCen
    +9:OldArcDistTip,+10:OldArcMid
    SA2_SIDE    ARC:sout13+4,+5,+6(=mid)
sout13+4:NewOldArcTip,sout13+5:NewArcTanTip,sout13+6:NewArcMid,sout13+7:NewArcCen
    sout13+8:poiP(On2OldArcCentersPassinglink. And OnTangentialLine)
    +11:OldArcDistTip,+12:OldArcMid
    */
   if(l==0)goto ltry;
   k_mknewvec(snlim,0,st_n+j,1,sj+9,sj,sj+10);/*sv1.old*/
   k_mknewvec(snlim,1,st_n+j+stp,1,sj,sj+1,sj+2);/*sv1.new*/
   k_mknewvec(snlim,2,st_n+j+stp2,1,sj+11,sj+4,sj+12);/*sv2.old*/
   k_mknewvec(snlim,3,st_n+j+stp3,1,sj+4,sj+5,sj+6);/*sv2.new*/
	    /*pltmds24=PYELLOW;k_1vecdisp(sj+9,sj,sj+10);getchar();
	    k_1vecdisp(sj,sj+1,sj+2);getchar();
	    k_1vecdisp(sj+11,sj+4,sj+12);getchar();
	    k_1vecdisp(sj+4,sj+5,sj+6);getchar();pltmds24=PCYAN;*/
			/*!! MustAlter scrs to sv1+2,sv2+2 midPoi*/
   j+=stp4;snlim++;
  lbaav:   k_PRITES(" 2vec.lbaav:st_n+j=%d",st_n+j);getchar();
   if((st_n+j+stp3+25/*!!+25*/)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.2vec()");goto la;}
  }

ltry:
  if((st_n+j+stp3+25/*!!+25*/)>=k_TMPXMAX)goto la;
      /* +5 is approx. MustConfirm by putvect(),delvec() in tryeval().*/
  k_tryeval(snlim,st_n+j,k_exparas8);/*TryEval(NumbOfCandidates,stmp,slev:gcbig_levl)
  /*?!! end flag to pair of lv1,lv2*/
la:
	k_showoldvec();k_shownewvecall(snlim);
 return;
}
/***/
k_3vec(lv1,lv2,sv1,sv2,scrs,st_n)
   /*ok. (lv1,lv2,sv1,sv2,scrs,st_n)
      (VecNum1,VecNum2,svec1,svec2,crospoi,stmp_n)
   lv1,sv1:ProtrudeSide */
short sv1,sv2,scrs,st_n;k_POITY lv1,lv2;
{short sn,snlim,j,smid,stp,stp2,stp3,sj,si,siout,sdp,sk;
 long l;double xmid,ymid,xold,yold,d;
   k_PRITES(" 3vec.lv1=%d",lv1);getchar();
 if(k_iflink(sv1)==0)goto la;
 sdp=k_poidisttip(sv2,sv2+1,scrs);
 stp=k_exparas16;
 stp2=stp+stp;stp3=stp2+stp;
 k_putoldvec(0,lv1);k_putoldvec(1,lv2);

 /*2link pair. so snlim=1 afterward.*/
 k_mknewvec(0,0,st_n,1,sv1,sv1+1,sv1+2);
 k_mknewvec(0,1,st_n+stp,1,sdp,scrs,sv2+2);
 xold=k_x[scrs];yold=k_y[scrs];
 sj=st_n+stp2;

 if(k_iflink(sv2)==0){/*sv1.link+sv2.arc*/j=stp2;snlim=1;goto ln2;}
 /*link+link*/
 l=k_getangmidby3poi(sv1,scrs,sdp,sj);k_sv2=sv1;k_sv4=sdp;
	/*Ret 1:good 0:fail(sp1,scen,sp2,soutpoi)*/
 if(l==0){snlim=1;j=stp2;goto ln;}
			 /*k_PRITES(" midby3=");k_showtmpx(sj,sj);*/
 l=k_sense(scrs,sj,k_exparad6);/*sense from sp1 to sp2
    (sp1:tip1 as k_x[this],sp2:tip2,MaxDxDy) ->k_sns*/
 if(l==0){snlim=1;j=stp2;goto ln;}
			 /*k_showsx();*/
	/*# must exclude sensed poi is crspoi.*/
 j=stp2;snlim=1;/*NumbOfCanddts*/ sn=0;/*sensed array pointer*/
 for(;;)/*foreach sensed point*/
  {xmid=k_sx[sn];ymid=k_sy[sn];
   if(fabs(xold-xmid)<k_exparad10&&fabs(yold-ymid)<k_exparad10)goto lb;
   /*R  ok*/
   /*if(k_x[sv1+2]!=k_NONARC||k_x[sv2+2]!=k_NONARC)goto lb;*//*Not(BothAreLink)*/
   l=k_getinterarcbymidpoi(sv1,sv2,xmid,ymid,st_n+j+stp3,scrs,st_n+j+stp3+3);
	 /*<-k_sv2,4 ->k_sv5,6 (sv1,sv2,xmid,ymid,sout3,scrs,st5)(xmid,ymid,crospoi,stmp)*/
   if(l==0)goto lb;
   xold=xmid;yold=ymid;
   sj=st_n+j+stp3+3;
   k_x[sj]=xmid;k_y[sj]=ymid;
   k_mknewvec(snlim,0,st_n+j,1,k_sv5,k_sv6,sj);
   k_mknewvec(snlim,1,st_n+j+stp,1,sv1,sv1+1,sv1+2);
   k_mknewvec(snlim,2,st_n+j+stp2,1,k_sv4,k_sv6,sv2+2);

			/*!! MustAlter scrs to sv1+2,sv2+2 midPoi*/
		       k_PRITES("NewArc=");k_showtmpx(st_n+j,st_n+j+2);
				 k_showtmpx(st_n+j+stp,st_n+j+stp+2);
				 k_showtmpx(st_n+j+stp2,st_n+j+stp2+2);
   j+=stp3;snlim++;
  lb:sn++;/*next sensed point*/
   if((st_n+j+stp3+25/*!!+25*/)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.3vec()");goto la;}
   if(sn>=k_sns||sn>=k_SXMAX)break;
  }

ln:  /*k_PRITES("_3vec.ln");getchar();*/
 sj=st_n+j;
 l=k_getangmidby3poi(sv1+1,scrs,sdp,sj);k_sv2=sv1+1;k_sv4=sdp;
	/*Ret 1:good 0:fail(sp1,scen,sp2,soutpoi)*/
 if(l==0){goto ln2;}
			 /*k_PRITES(" midby3=");k_showtmpx(sj,sj);*/
 l=k_sense(scrs,sj,k_exparad6);/*sense from sp1 to sp2
    (sp1:tip1 as k_x[this],sp2:tip2,MaxDxDy) ->k_sns*/
 if(l==0){goto ln2;}
			 /*k_showsx();*/
	/*# must exclude sensed poi is crspoi.*/
 sn=0;/*sensed array pointer*/
 for(;;)/*foreach sensed point*/
  {xmid=k_sx[sn];ymid=k_sy[sn];
   if(fabs(xold-xmid)<k_exparad10&&fabs(yold-ymid)<k_exparad10)goto lb2;
   /*R  ok*/
   /*if(k_x[sv1+2]!=k_NONARC||k_x[sv2+2]!=k_NONARC)goto lb2;*//*Not(BothAreLink)*/
   l=k_getinterarcbymidpoi(sv1,sv2,xmid,ymid,st_n+j+stp3,scrs,st_n+j+stp3+3);
	 /*<-k_sv2,4 ->k_sv5,6 (sv1,sv2,xmid,ymid,sout3,scrs,st5)(xmid,ymid,crospoi,stmp)*/
   if(l==0)goto lb2;
   xold=xmid;yold=ymid;
   sj=st_n+j+stp3+3;
   k_x[sj]=xmid;k_y[sj]=ymid;
   k_mknewvec(snlim,0,st_n+j,1,k_sv5,k_sv6,sj);
   k_mknewvec(snlim,1,st_n+j+stp,1,sv1,sv1+1,sv1+2);
   k_mknewvec(snlim,2,st_n+j+stp2,1,k_sv4,k_sv6,sv2+2);

			/*!! MustAlter scrs to sv1+2,sv2+2 midPoi*/
		       k_PRITES("NewArc=");k_showtmpx(st_n+j,st_n+j+2);
				 k_showtmpx(st_n+j+stp,st_n+j+stp+2);
				 k_showtmpx(st_n+j+stp2,st_n+j+stp2+2);
   j+=stp3;snlim++;
  lb2:sn++;/*next sensed point*/
   if((st_n+j+stp3+25/*!!+25*/)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.3vec()");goto la;}
   if(sn>=k_sns||sn>=k_SXMAX)break;
  }

ln2: k_PRITES("_3vec.ln2");getchar();
  {if(k_iflink(sv2)==1)goto ltry;
   /*sv2 is arc*/
	/*k_PRITES(" 3vec.ln2.b.cen");getchar();*/
   /*Arctan ok*/
   sj=st_n+j+stp3;/*sj:WorkArea, st_n+j:NewVecsToHere*/
   l=k_arccentor(sv2,sv2+1,sv2+2,sj,sj+1);/*!!Slow. MustGetFrom lv2*/
   /*(k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
   if(l==0)goto ltry;
	/*k_PRITES(" 3vec.ln2.a.cen");getchar();*/
   d=k_rr;
   l=k_arctan(sv2,sv1,sj,d,k_exparad14,k_exparad15,sj+1,sj+5);
			/*Attention exparad15*/
     /*(sa,stl,sc,dr,ddef,dlim,sout4,st12)
 sout4:TipBtwnOldArcAndNewArc,sout4+1:NewArcTip=TanPoi,sout4+2:NewArcMid
 sout4+3:NewArcCentr
     sj:OldArcCen,sj+1:TipBtwnOldArcAndNewArc,sj+2:TanPoi,sj+3:NewArcMid
     sj+4:NewArcCen,  sj+5:OldArcNewMid sk:OldArcDistTip*/
       /*k_1vecdisp(sj+1,sj+2,sj+3);*/
   if(l==0)goto ltry;
	/*k_PRITES(" 3vec.ln2.a.arccen");getchar();*/
   sk=k_poidisttip(sv2,sv2+1,sj+1);
   l=k_div2arcfast(sk,sj+1,sj,d,sj+5,sj+6);if(l==0)goto ltry;
	/*k_PRITES(" 3vec.ln2.a.div2");getchar();*/
  /*ok.DivideArcto2.(tip1 as k_x[this],tip2,cen,d_radius,sout,stmp1)*/
   k_mknewvec(snlim,0,st_n+j,1,sj+1,sj+2,sj+3);/*NewArc*/
		    /*k_1vecdisp(sj+1,sj+2,sj+3);getchar();*/
   k_mknewvec(snlim,1,st_n+j+stp,1,sv1,sv1+1,sv1+2);/*!!CanSkipExistCheck*/
   k_mknewvec(snlim,2,st_n+j+stp2,1,sk,sj+1,sj+5);

			/*!! MustAlter scrs to sv1+2,sv2+2 midPoi*/
		       k_PRITES("NewArc=");k_showtmpx(st_n+j,st_n+j+2);
				 k_showtmpx(st_n+j+stp,st_n+j+stp+2);
				 k_showtmpx(st_n+j+stp2,st_n+j+stp2+2);
   j+=stp3;snlim++;
   if((st_n+j+stp3+25/*!!+25*/)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.3vec()");goto la;}
  }

ltry:
  if((st_n+j+stp3+25/*!!+25*/)>=k_TMPXMAX)goto la;
      /* +5 is approx. MustConfirm by putvect(),delvec() in tryeval().*/
  k_tryeval(snlim,st_n+j,k_exparas8);/*TryEval(NumbOfCandidates,stmp,slev:gcbig_levl)
  /*?!! end flag to pair of lv1,lv2*/
la:
	k_showoldvec();k_shownewvecall(snlim);
 return;
}
/***/
k_4vec(lv1,lv2,sv1,sv2,scrs,st_n)
   /*ok. (lv1,lv2,sv1,sv2,scrs,st_n)
      (VecNum1,VecNum2,svec1,svec2,crospoi,stmp_n)
   <-k_exparad12:LimBtwnCrsAndLinkTip
   */
short sv1,sv2,scrs,st_n;k_POITY lv1,lv2;
{short sn,snlim,smid,stp,stp2,stp3,stp4,sj,j;
 long l;double xmid,ymid,xold,yold,d;
   k_PRITES(" 4vec.");getchar();
 stp=k_exparas16;
 stp2=stp+stp;stp3=stp2+stp;stp4=stp3+stp;
 k_putoldvec(0,lv1);k_putoldvec(1,lv2);

 /*2link pair. so snlim=1 afterward.*/
 k_mknewvec(0,0,st_n,1,sv1,sv1+1,sv1+2);
 k_mknewvec(0,1,st_n+stp,1,sv2,sv2+1,sv2+2);
 sj=st_n+stp2;

 snlim=1;/*NumbOfCanddts*/ sn=0;/*sensed array pointer*/

 l=k_iflink(sv1);if(l==0)goto la;/*lb;*/
 l=k_iflink(sv2);if(l==0)goto la;/*lb;*/

 /*to2Arcs  ok*/
 l=k_crs2linksto2arcs(sv1,sv2,sj+stp4,sj+stp4+8);
  /*ok.Type4 2CrsLinks to 2Arcs. RET1:good,0:fail
  (sl1,sl2,sout8,stmp3)
  <-k_exparad12:LimBtwnCrsAndLinkTip
  sl1's sl1 side Arc+SmallLink
  sout8:ShorterTip=ArcTip,sout8+1:Crspoi
  ,sout8+2:ArcTip=SmallLinkTip,sout8+3:SmallLinkTip
  sl1's sl1+1 side Arc+SmallLink
  sout8+4:ShorterTip=ArcTip,sout8+5:Crspoi
  ,sout8+6:ArcTip=SmallLinkTip,sout8+7:SmallLinkTip
  ->(short)k_out1:Is(shorter side link(in sout8to+3))sl1 or sl2.
  ->(short)k_out2:Is(shorter side link(in sout8+4to+7))sl1 or sl2.
  */
  if(l==0)goto la;/*lb;*/
   j=sj+stp4;/*sout8*/
   k_mknewvec(snlim,0,sj,1,j,j+2,j+1);/*arc*/
   k_mknewvec(snlim,1,sj+stp,1,j+2,j+3,sv1+2);/*link*/
   k_mknewvec(snlim,2,sj+stp2,1,j+4,j+6,j+5);/*arc*/
   k_mknewvec(snlim,3,sj+stp3,1,j+6,j+7,sv1+2);/*link*/

			/*!! MustAlter scrs to sv1+2,sv2+2 midPoi*/
		       k_PRITES("NewArc=");k_showtmpx(st_n+j,st_n+j+2);
				 k_showtmpx(sj+stp,sj+stp+2);
				 k_showtmpx(sj+stp2,sj+stp2+2);
   sj+=stp4;snlim++;
  lb:
   if((sj+stp4+25/*!!+25*/)>=k_TMPXMAX){k_PRIWARN(" wr.ov.TMPX.4vec()");goto la;}

ltry:
  if((sj+stp4+25/*!!+25*/)>=k_TMPXMAX)goto la;
      /* +25 is approx. MustConfirm by putvect(),delvec() in tryeval().*/
  k_tryeval(snlim,st_n+j,k_exparas8);/*TryEval(NumbOfCandidates,stmp,slev:gcbig_levl)
  /*?!! end flag to pair of lv1,lv2*/
la:
	k_showoldvec();k_shownewvecall(snlim);
 return;
}
/***/
k_mknewvec(n,i,sv,sprio,sp1,sp2,smid)
  /*ok.MakeNew1VecAsEval if smid=-1 NONARC*/
short n,i,sv,sprio,sp1,sp2,smid;
{k_putnewvec(n,i,sv,sprio);
 k_puttmp3x(sv,sp1,sp2,smid);
	   k_1vecdisp(sp1,sp2,smid);/*!! test*/
}
/**ArcConnection***************************/
long k_linktanpoi(sl,stl,stp,sout3,st6)
 /*ok.GIVEN=Link,TangentialLink,TanPoi
 GET=ConctPoiOnLink,CentrOfTangentialArc,ArcMidPoi
 RET 1:good,0:fail
 (sl,stl,stp,sout3,st6)(link,tanlink,tanPoiOnTanLink,sout3,stmp6)
 sout3:ConstPoiOnSL,sout3+1:tangntialArcCentor,sout3+2:tanArcMidPoi
 stp must be on stl.
 NeedNot getnearpoi() before.
 */
short sl,stl,stp,sout3,st6;
{long l;double d,d1,d2,dcos,dsin,r;short sj;
 d1=k_2poidist(stl,stp,0);d2=k_2poidist(stl+1,stp,0);
 if(d1>=d2)sj=stl;else sj=stl+1;
 k_rot90(sj,stp,st6+5);k_sendpoi(stp,st6+4);
 l=k_llcross(sl,st6+4,st6+3,st6);/*(sl1,sl2,sout1,st3)*/
 if(l==0){goto lfail;}
 d1=k_2poidist(sl,st6+3,0);d2=k_2poidist(sl+1,st6+3,0);
 if(d1>=d2)sj=sl;else sj=sl+1;
 dcos=k_cosby3poi(sj,st6+3,stp);/*(sp1,scen,sp2)*/
 if(dcos<=k_cstol){goto lfail;}/*sl is on stl, or theta is blunt angle.*/
 d=1.0-dcos*dcos;if(d<=k_cstol){goto lfail;}/*sl is right to stl*/
 dsin=sqrt(d);
 d2=k_2poidist(st6+3,stp,1);if(d2<=k_lentol)goto lfail;/*crs is stp*/
   /*dsin=r/(d2+r) -> d2*dsin+r*dsin=r ->r*(1.0-dsin)=d2*dsin*/
 d=1.0-dsin;if(fabs(d)<=k_lentol)goto lfail;
 r=(d2*dsin)/d;d=(d2+r)/d2;
 k_x[sout3+1]=k_x[st6+3]+d*(k_x[stp]-k_x[st6+3]);
 k_y[sout3+1]=k_y[st6+3]+d*(k_y[stp]-k_y[st6+3]);
 k_rightpoint(sout3+1,sl,sout3);
 l=k_div2arcfast(sout3,stp,sout3+1,r,sout3+2,st6+4);/*(sp1,sp2,scen,dr,sout,st1)*/
 if(l==0)goto lfail;
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
k_transvec(sl,sp,d,sout2,st1)
  /*ok.TranslateLink sl as link to dire point sp with dist d.
  (sl,sp,d,sout2,st1) if(sp is on sl)NotMove.
  sout2,+1:NewLink2Tips. sl(+1) to sout2(+1).*/
short sl,sp,sout2,st1;double d;
{double dd,d1,dx,dy;
 k_rightpoint(sp,sl,st1);
 d1=k_2poidist(st1,sp,1);if(d1<=k_lentol){dx=0.0;dy=0.0;goto la;}
 dd=d/d1;
 dx=dd*(k_x[sp]-k_x[st1]);dy=dd*(k_y[sp]-k_y[st1]);
la:
 k_x[sout2]=k_x[sl]+dx;k_y[sout2]=k_y[sl]+dy;
 k_x[sout2+1]=k_x[sl+1]+dx;k_y[sout2+1]=k_y[sl+1]+dy;
 return;
}
/***/
long k_linktan(sl,stl,sp,stp,sout3,st7)
 /*ok.GIVEN:Link,TanLink,PointOnLink,AnyPointOnTanLink.
   GET:AcrCnctPoiOnTanLink,ArcCen,ArcMid
  (sl,stl,sp,stp,sout3,st7)(Link,TanLink,PointOnLink=NewArcTip
  ,ReprsnttvPointOnTanLink,sout3,stmp7)
  Arc is generated to stp existing side.
  stp must not be at crspoi btwn sl,stl.  RET 1:good,0:fail
  Arc can be 2. But stp side arc is generated.
  sout3:ConctPoiOnStl,sout3+1:NewArcMid,sout3+2:NewAcrCen.
  ->k_rr:NewArcRadius
  Attention:NewArc=sp,sout3,sout3+1(mid)
  Attention:NotChangeSl,Stl.
 */
short sl,stl,sp,stp,sout3,st7;
{long l;double d,d1,d2,d3;
 l=k_llcross(sl,stl,st7+3,st7);if(l==0)goto lfail;
 l=k_getangmidby3poi(sp,st7+3,stp,st7+4);if(l==0)goto lfail;
		  /*st+3,+4:MidLink*/
 k_rightpoint(sp,st7+3,st7+5);/*st+3:Crs,st+4:AngDiv2Poi,st+5:rightPoiOnDiv2Link*/
 d1=k_2poidist(st7+3,st7+5,1);d2=k_2poidist(sp,st7+5,1);
 if(d1<=k_lentol)goto lfail;
 d3=(d2*d2)/d1;d=(d3+d1)/d1;/*d2/d1=d3/d2.*/
 k_x[sout3+2]=k_x[st7+3]+d*(k_x[st7+5]-k_x[st7+3]);
 k_y[sout3+2]=k_y[st7+3]+d*(k_y[st7+5]-k_y[st7+3]);
 k_rightpoint(sout3+2,stl,sout3);k_rr=k_2poidist(sp,sout3+2,1);
     /*k_PRITES(" stl,sout3+2=%d",stl);k_showtmpx(sout3+2,sout3+2);*/
 l=k_div2arcfast(sp,sout3,sout3+2,k_rr,sout3+1,st7+6);
 if(l==0)goto lfail;
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
long k_fillet(sl1,sl2,sp,sout2,st10)
 /*ok.Mentori(sl1,sl2,sp,sout2,st10)
 (link1,link2,MentoriPoi,OutMentori2Tips,stmp10)   Ret,1:good,0:fail.
 There can be simpler+faster way with that (sp is as MidOfMentori).
 ->sout1:sl1 side,sout1+1:sl2 side.
 */
short sl1,sl2,sp,sout2,st10;
{long l;short sj1,sj2;double d1,d2;
 l=k_llcross(sl1,sl2,st10+3,st10);if(l==0)goto lfail;/*st+3:CrsPoi*/
 d1=k_2poidist(sl1,st10+3,0);d2=k_2poidist(sl1+1,st10+3,0);
 if(d1>=d2)sj1=sl1;else sj1=sl1+1;/*distant one*/
 d1=k_2poidist(sl2,st10+3,0);d2=k_2poidist(sl2+1,st10+3,0);
 if(d1>=d2)sj2=sl2;else sj2=sl2+1;
 l=k_getangmidby3poi(sj1,st10+3,sj2,st10+4);/*st+3,+4:MidLink*/
 if(l==0)goto lfail;
 k_rightpoint(sp,st10+3,st10+5);/*st+5:MidOfMentori*/
 k_rot90(st10+3,st10+5,st10+6);/*st+5,+6:MenLink*/
 l=k_llcross(sl1,st10+5,sout2,st10+7);if(l==0)goto lfail;
 l=k_llcross(sl2,st10+5,sout2+1,st10+7);if(l==0)goto lfail;
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
long k_linklink(sl1,sl2,sp1,sp2,scrs,sout4,st7)
 /*ok.ContinuousArc btwn linklink.Ret1:good,0:fail.
 (sl1,sl2,sp1,sp2,scrs,sout4,st7)
 (link1,link2,poi1,poi2,CrossPoiBtwn2Links,sout,stmp7)
 sp1:PoiNearCrsPoiOnLink1,sp2:PoiNearCrsPoiOnLink2.
 MustGiveCrsPoi as scrs.
 VerySimilar linktan(). Can program with linktan().
 The Location of sp1,sp2 must not at CrsPoi.
 sout4:=sp1 or sp2(near one)=tip1,sout4+1:tip2,sout4+2:ArcMid,sout4+3:centr.
 ->k_rr:NewArcRadius
 */
short sl1,sl2,sp1,sp2,scrs,sout4,st7;
{long l;double d1,d2,dr;short sj,sj2,sjl;
 l=k_ifonlink(sl1,scrs);if(l==1)goto lfail;
 l=k_ifonlink(sl2,scrs);if(l==1)goto lfail;
 d1=k_2poidist(scrs,sp1,0);d2=k_2poidist(scrs,sp2,0);
 if(d1<=d2){sj=sp1;sj2=sp2;sjl=sl2;}else{sj=sp2;sj2=sp1;sjl=sl1;}
	     /*sj:nearpoi,sj2:distant,sjl:itsOther!Link*/
 if(d1<=k_lentol||d2<=k_lentol)goto lfail;
 l=k_getangmidby3poi(sp1,scrs,sp2,st7);if(l==0)goto lfail;
 k_sendpoi(scrs,st7+1);/*st,+1:MidLink*/
 k_rot90(scrs,sj,st7+2);k_sendpoi(sj,st7+3);/*st+2,+3:LinkRightCrossesSj*/
 l=k_llcross(st7,st7+2,sout4+3,st7+4);if(l==0)goto lfail;
 k_rightpoint(sout4+3,sjl,sout4+1);
 k_sendpoi(sj,sout4);
 dr=k_2poidist(sout4,sout4+3,1);k_rr=dr;
 l=k_div2arcfast(sout4,sout4+1,sout4+3,dr,sout4+2,st7+4);if(l==0)goto lfail;
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
long k_arctanpoi(sa,stl,stp,sc,dr,sout3,st5)
 /*ok.ArcWithGivenTangentialPoi(sa,stl,stp,sc,dr,sout3,st5)
 (arc(NeedNotGiveMidPoi),TanLink,PointOnTanLink(FixedNewArcTip),sa's centor
 ,sa's radius,sout3,stmp5)
 sout3:NewArcTip(OtherTip is stp),sout3+1:NewArcMid,sout3+2:NewArcCentr
 ->k_rr:NewArcRadius
 If sout3 is nonarc, sout3+1 is k_NONARC and sout3+2 has no_meaning.
 ! So,You need check k_NONARC aft this func.
 !!yet. If sa and stl crosses, result is not good.
 Ret1:good,0:fail.
 Attention:
   When Sc is on the line that is NormalToStlPassingStp,
       Result is good, but is not useful.
 */
short sa,stl,stp,sc,sout3,st5;double dr;
{long l;double d1,d2,da,de,df,dx,drbig,d,dd;short sj;
 d1=k_2poidist(stl,stp,0);d2=k_2poidist(stl+1,stp,0);
 if(d1>=d2)sj=stl;else sj=stl+1;/*distant tip*/
 k_rot90(sj,stp,st5+1);k_sendpoi(stp,st5+2);/*st+1,+2:rightlink of stl*/
 k_rightpoint(sc,st5+1,st5+3);/*st+3:point A:rightpoi*/
 de=k_2poidist(st5+3,sc,1);df=k_2poidist(st5+3,stp,1);
     /*k_PRITES(" de=%f",de);k_PRITES(" df=%f",df);*/
 /* da=(drbig-dr)-(drbig-df) drbig:RadiusOfTangentialNewArc*/
 da=df-dr;/*yet!!?if(da<0.0)goto lfail;*/
     /*k_PRITES(" da=%f",da);*/
 if(fabs(da)<=k_lentol)goto la;/*given arc is tangential*/
 /* (dx+da)**2=de**2+dx**2 triangle*/
 dx=(de*de-da*da)/(2.0*da);
     /*k_PRITES(" dx=%f",dx);*/
 /*NewArcCentr*/
 if(fabs(df)<=k_lentol)goto lfail;
 drbig=df+dx;d=drbig/df;k_rr=drbig;
     /*k_PRITES(" drbig=%f",drbig);*/
 k_x[sout3+2]=k_x[stp]+d*(k_x[st5+3]-k_x[stp]);
 k_y[sout3+2]=k_y[stp]+d*(k_y[st5+3]-k_y[stp]);
 /*NewArcTip*/
 dd=drbig-dr;if(fabs(dd)<=k_lentol)goto la;
     /*k_PRITES(" dd=%f",dd);*/
 d=drbig/dd;
     /*k_PRITES(" d=%f",d);*/
 k_x[sout3]=k_x[sout3+2]+d*(k_x[sc]-k_x[sout3+2]);
 k_y[sout3]=k_y[sout3+2]+d*(k_y[sc]-k_y[sout3+2]);
 k_div2arcfast(sout3,stp,sout3+2,drbig,sout3+1,st5+4);
 /*NotCheck ifonarc() */
 l=1;goto lend;

la:/*given arc is tangential*/
     /*k_PRITES(" la");*/
 k_rightpoint(sc,stl,st5);
 k_x[sout3]=k_x[st5];k_y[sout3]=k_y[st5];
 k_x[sout3+1]=(double)k_NONARC;
 l=1;goto lend;

lfail:l=0;
lend:return(l);
}
/***/
long k_arctan(sa,stl,sc,dr,ddef,dlim,sout4,st12)
 /*ok.GetTangentialArcBtwnArcAndLink. Unknown:NewArc2Tips
 (sa,stl,sc,dr,ddef,dlim,sout4,st12)
 (OldArcAs2Tips(NeedNotMid=3rdPoi),TanLink2Tips(NeedNot3rdPoi),OldArcCEntr
  ,OldArcRadius,StlTranslationLength=>NewArcTipLocatesThere,NewArcLengthLim
  ,sout4,stmp12)
  ->k_rr:NewArcRadius
 sout4:TipBtwnOldArcAndNewArc,sout4+1:NewArcTip=TanPoi,sout4+2:NewArcMid
 sout4+3:NewArcCentr
 Stl is translated ddef todire sc. This line is crossed to OldArcSa.
      CrossPoi is sout4=ArcTip.   If NotCross,Fail.
 If OldArcBoth2Tips are near within ddef to stl, then fail.
 If AprLengthBtwnNewArc2Tips are >= dlim, then fail.
 Ret1:good,0:fail.
 */
 /*!!?check=ifonarc(sout4+0)*/
short sa,stl,sc,sout4,st12;double dr,ddef,dlim;
{double d1,d2,de,dm,dcos,dsin,dd,dx,d;long l;short sj,sk;
 d1=k_poilinkdist(sa,stl,st12,0);d2=k_poilinkdist(sa+1,stl,st12,0);
		 /*(,,stmp1,) #CanDoFaster.*/
		 /*k_PRITES(" d1=%f",d1);k_PRITES(" d2=%f",d2);*/
 if(d1>=d2)sj=sa;else sj=sa+1;/*distant one from stl*/
		 /*k_PRITES(" sj=%d",sj);*/
 if(d1<ddef&&d2<ddef)goto lfail;
 k_transvec(stl,sc,ddef,st12+1,st12);/*st+1,+2:TranslatedLink*/
     /*(sl,sp,d,sout2,st1)*/
 k_rightpoint(sc,st12+1,st12+3);/*st:pointG*/
 k_rightpoint(sc,stl,st12);/*st:pointD*/
	 /*k_PRITES(" PoiG=");k_showtmpx(st12+3,st12+3);
	 k_PRITES(" PoiD=");k_showtmpx(st12,st12);
	 k_PRITES(" TransVec=");k_showtmpx(st12+1,st12+2);*/
 l=k_lccrossd(sc,st12+3,st12+4,st12+6,dr);/*st+4,+5:2CrsPoi*/
   /* (CirCentr,CenRightpoiToLink,OutCross2Points,1Temp,InputArcRadius) */
	 /*k_PRITES(" 2CrsPoi=");k_showtmpx(st12+4,st12+5);*/
 if(l==0)goto lfail;
 if(k_x[st12+4]==k_x[st12+5]&&k_y[st12+4]==k_y[st12+5])goto lfail;
 d1=k_2poidist(st12+4,sj,1);d2=k_2poidist(st12+5,sj,1);/*!! (,,1) slow*/
 if(d1<=d2)sk=st12+4;else sk=st12+5;/*near one to sj. pointB*/
	 /*k_PRITES(" poiB=");k_showtmpx(sk,sk);*/
 de=k_2poidist(sc,st12,1);
	 /*k_PRITES(" de=%f",de);*/
 k_sendpoi(sk,st12+6);k_sendpoi(sc,st12+7);/*st+6,+7:linkBC*/
	 /*k_PRITES(" LinkB,C=");k_showtmpx(st12+6,st12+7);*/
 l=k_llcross(st12+6,stl,st12+11,st12+8);
 if(l==0)goto lfail;
 dcos=k_cosby3poi(st12+7,st12+11,st12);
 dd=1.0-dcos*dcos;
	 /*k_PRITES(" dd=%f",dd);*/
 if(fabs(dd)<=k_cstol)goto lfail;
 dsin=sqrt(dd);
 /*dsin=(dm-de)/(dm-dr),dm*dsin-dr*dsin=dm-de,dm*(dsin-1.0)=dr*dsin-de.*/
 dd=dsin-1.0;
 if(fabs(dd)<=k_cstol)goto lfail;
 dm=(dr*dsin-de)/dd;k_rr=dm;
     /*k_PRITES(" dm=%f",dm);*/
 if(fabs(dsin)<=k_cstol)goto lfail;
 dx=(dm-de)/dsin;
     /*k_PRITES(" dx=%f",dx);*/
 if(fabs(dr)<=k_lentol)goto lfail;
 /*pointE*/d=(dr+dx)/dr;
 k_x[sout4+3]=k_x[st12+6]+d*(k_x[sc]-k_x[st12+6]);
 k_y[sout4+3]=k_y[st12+6]+d*(k_y[sc]-k_y[st12+6]);
 k_sendpoi(st12+6,sout4);
 /*pointF*/k_rightpoint(sout4+3,stl,sout4+1);
 /*Mid*/l=k_div2arcfast(sout4,sout4+1,sout4+3,dm,sout4+2,st12+10);
 if(l==0)goto lfail;
 d1=k_2poidist(sout4,sout4+1,0);if(d1>=dlim)goto lfail;
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/**************************/
long k_iflink(sv)/*ok.if(sv=vector(check.sv+2))is link RET1 else RET0.*/
short sv;
{long l;
 if(k_x[sv+2]!=k_NONARC)/*arc*/l=0;else l=1;
 return(l);
}
/***/
short k_selectbasevec(sv1,sv2)
 /*ok.RET sv1 or sv2.  ->k_bsv=Base=longer,k_2ndv=shorter. RET=k_bsv*/
short sv1,sv2;
{short s;double d1,d2;
 d1=k_veclen(sv1,1);d2=k_veclen(sv2,1);
 if(d1>=d2){s=sv1;k_bsv=sv1;k_2ndv=sv2;}else{s=sv2;k_bsv=sv2;k_2ndv=sv1;}
 return(s);
}
/***/
long k_linktandef(sl,stl,ddef,stp,sout4,st8)
  /*ok.stl is translated ddef to sl. It and sl cross poi is NewArcTip.
  (sl:link,stl:TanLink,ddef,stp:ArcSideOnStl,sout4,st8)
  Arc is generated to stp existing side.
  stp must not be at crspoi btwn sl,stl.  RET 1:good,0:fail
  Arc can be 2. But stp side arc is generated.
  ->sout4:NewArcTipPoiOnStl,sout4+1:NewArcMid,sout4+2:NewAcrCen
    ,sout4+3:NewArcTipOnSl.
  NewArc:sout4+3,sout4,sout4+1(mid)
  Attention:NotChangeSl,Stl.
  ->k_rr:NewArcRadius
  */
short sl,stl,ddef,stp,sout4,st8;double ddef;
{long l;
 k_x[st8]=(k_x[sl]+k_x[sl+1])/2.0;k_y[st8]=(k_y[sl]+k_y[sl+1])/2.0;
 k_transvec(stl,st8,ddef,st8+1,st8+3);/*(sl,sp,d,sout2,st1)*/
 l=k_llcross(sl,st8+1,st8+4,st8+5);/*(sl1,sl2,sout1,st3)*/
 if(l==0)goto lfail;
 k_sendpoi(st8+4,st8);
 l=k_linktan(sl,stl,st8,stp,sout4,st8+1);/*(sl,stl,sp,stp,sout3,st7)*/
 if(l==0)goto lfail;
 k_sendpoi(st8,sout4+3);
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
long k_arcarcvalley(sa1,sa2,ddef,dlim,sout13,st36)
    /*ok.Case there are 2Arcs as a valley. 2NewTangentialArcs are generated.
    (sa1,sa2,ddef=TransltDifFromTanLine,dlim=NewArcLenthLim,sout13,st36)
    RET1:good,0:fail
    sa1,sa2:Arc3Poi(2Tips,1Mid)
    <-k_radtol:if this is small, arc cross is not found.
    ->SA1_SIDE  ARC:sout13,+1,+2(=mid)
  sout13:NewOldArcTip,sout13+1:NewArcTanTip,sout13+2:NewArcMid,sout13+3:NewArcCen
    +9:OldArcDistTip,+10:OldArcMid
    SA2_SIDE    ARC:sout13+4,+5,+6(=mid)
sout13+4:NewOldArcTip,sout13+5:NewArcTanTip,sout13+6:NewArcMid,sout13+7:NewArcCen
    sout13+8:poiP(On2OldArcCentersPassinglink. And OnTangentialLine)
    +11:OldArcDistTip,+12:OldArcMid
    */
/*#YetTest.NeedOldArcTip,Mid.CheckIfOnArc.  +9,10,11,12*/
short sa1,sa2,sout13,st36;double ddef,dlim;
{long l;short sk;
 l=k_cccross(sa1,sa2,st36,st36+2);
     /*# If there are radius,centor,Can do faster.*/
	   /*ok.CircCircCross Ret1:good,2:Near,0:NotCrs <-k_radtol
		 ->st22+9(sc1Side),+19(sc2Side):ArcCentr  ->k_rr1,2
		 (sc1:Arc3poi,sc2:Acr3Poi,sout2:2CrsPoi,st22:22temp)*/
 if(l==0)goto lfail;
 k_x[st36]=(k_x[st36]+k_x[st36+1])/2.0;k_y[st36]=(k_y[st36]+k_y[st36+1])/2.0;
			     /*st36:poiP*/
	   /*st36+11:sa1ArcCentr,  st36+21:sa2ArcCentr*/
 k_rot90(st36+11,st36,st36+1);/*st36,+1:TanLink*/
 k_sendpoi(st36,sout13+8);                /*k_PRITES(" k_rr1=%f",k_rr1);*/
		    /*k_1vecdisp(st36+11,st36+11,-1);*/
 l=k_arctan(sa1,st36,st36+11,k_rr1,ddef,dlim,sout13,st36+24);
	/*(sa,stl,sc,dr,ddef,dlim,sout4,st12)*/
		/*k_1vecdisp(st36,st36+1,-1);
		k_1vecdisp(sout13,sout13,-1);k_1vecdisp(sout13+1,sout13+1,-1);
		k_1vecdisp(sout13+2,sout13+2,-1);*/
 if(l==0)goto lfail;
 l=k_ifonarc(sa1,sout13);if(l==0)goto lfail;
		    /*k_1vecdisp(st36+21,st36+21,-1);*/
 sk=k_poidisttip(sa1,sa1+1,sout13+8);
 k_sendpoi(sk,sout13+9);
 l=k_div2arcfast(sout13,sk,st36+11,k_rr1,sout13+10,st36+24);if(l==0)goto lfail;
		  /*(tip1 as k_x[this],tip2,cen,d_radius,sout,stmp1)*/
 l=k_arctan(sa2,st36,st36+21,k_rr2,ddef,dlim,sout13+4,st36+24);
 if(l==0)goto lfail;
 l=k_ifonarc(sa2,sout13+4);if(l==0)goto lfail;
 sk=k_poidisttip(sa2,sa2+1,sout13+8);
 k_sendpoi(sk,sout13+11);
 l=k_div2arcfast(sout13+4,sk,st36+21,k_rr2,sout13+12,st36+24);if(l==0)goto lfail;
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
long k_crs2linksto2arcs(sl1,sl2,sout8,st3)
  /*ok.Type4 2CrsLinks to 2Arcs. RET1:good,0:fail
  (sl1,sl2,sout8,stmp3)
  <-k_exparad12:LimBtwnCrsAndLinkTip
  sl1's sl1 side Arc+SmallLink
  sout8:ShorterTip=ArcTip,sout8+1:Crspoi
  ,sout8+2:ArcTip=SmallLinkTip,sout8+3:SmallLinkTip
  sl1's sl1+1 side Arc+SmallLink
  sout8+4:ShorterTip=ArcTip,sout8+5:Crspoi
  ,sout8+6:ArcTip=SmallLinkTip,sout8+7:SmallLinkTip
  ->(short)k_out1:Is(shorter side link(in sout8to+3))sl1 or sl2.
  ->(short)k_out2:Is(shorter side link(in sout8+4to+7))sl1 or sl2.
  */
short sl1,sl2,sout8,st3;
{long l;double d1,d2,da,d;short sj,sk,ss,sl;
 l=k_llcross(sl1,sl2,st3,st3+1);if(l==0)goto lfail;/*st3:cross*/
	 /*(sl1,sl2,sout1,st3)*/
 l=k_ifonlink(sl1,st3);if(l==0)goto lfail;
 l=k_ifonlink(sl2,st3);if(l==0)goto lfail;

 /*sl1's sl1 point*/
 d1=k_2poidist(st3,sl1,1);if(d1<=k_exparad12)goto lfail;
 da=k_cosby3poi(sl2,st3,sl1);
 if(da<=0.0){sj=sl2;sk=sl2+1;}else{sj=sl2+1;sk=sl2;}

 d2=k_2poidist(st3,sj,1);if(d2<=k_exparad12)goto lfail;
 if(d1<=d2){ss=sl1;sl=sj;}else{ss=sj;sl=sl1;}/*shorter,longer ones*/
    /*k_PRITES(" ss=%d",ss);k_PRITES(" sl=%d",sl);getchar();*/
 d=d1/d2;if(d>1.0)d=1.0/d;/*d<=1.0*/
 k_x[st3+1]=k_x[st3]+d*(k_x[sl]-k_x[st3]);/*st3+1:poiC*/
 k_y[st3+1]=k_y[st3]+d*(k_y[sl]-k_y[st3]);/*st3+1:poiC*/
 k_x[sout8]=k_x[ss];k_y[sout8]=k_y[ss];
 k_x[sout8+1]=k_x[st3];k_y[sout8+1]=k_y[st3];
 k_x[sout8+2]=k_x[st3+1];k_y[sout8+2]=k_y[st3+1];
 k_x[sout8+3]=k_x[sl];k_y[sout8+3]=k_y[sl];
 k_out1=ss;if(k_out1!=sl1)k_out1=sl2;
 /*sl1's sl1+1 point*/
 d1=k_2poidist(st3,sl1+1,1);if(d1<=k_exparad12)goto lfail;
 d2=k_2poidist(st3,sk,1);if(d2<=k_exparad12)goto lfail;
 if(d1<=d2){ss=sl1+1;sl=sk;}else{ss=sk;sl=sl1+1;}
    /*k_PRITES(" ss=%d",ss);k_PRITES(" sl=%d",sl);getchar();*/
 d=d1/d2;if(d>1.0)d=1.0/d;/*d<=1.0*/
 k_x[st3+2]=k_x[st3]+d*(k_x[sl]-k_x[st3]);
 k_y[st3+2]=k_y[st3]+d*(k_y[sl]-k_y[st3]);
 k_x[sout8+4]=k_x[ss];k_y[sout8+4]=k_y[ss];
 k_x[sout8+5]=k_x[st3];k_y[sout8+5]=k_y[st3];
 k_x[sout8+6]=k_x[st3+2];k_y[sout8+6]=k_y[st3+2];
 k_x[sout8+7]=k_x[sl];k_y[sout8+7]=k_y[sl];
 k_out2=ss;if(k_out2==sl1+1)k_out2=sl1;else k_out2=sl2;
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
long k_ifk(sv1,sv2,sv3,st6)
  /*ok.IfPatternK  RET1:yes,0:no (sv1,sv2,sv3,stmp6)
   sv1,2,3 must have 3points(tip1,tip2,mid/k_NONARC)
   <-k_exparad11:Veryshortvec is neglected.
   <-k_exparad13:NearLimToCrsPoi
   ->k_v1,2,3:=(sv1,2,3ByChangingOrder. k_v3:MasterVec)
   */
short sv1,sv2,sv3,st6;
{long l,lcount;double d;short s,s6;short ar[8];
 d=k_veclen(sv1,0);if(d<=k_exparad11)goto lfail;
 d=k_veclen(sv2,0);if(d<=k_exparad11)goto lfail;
 d=k_veclen(sv3,0);if(d<=k_exparad11)goto lfail;
 l=k_llcross(sv1,sv2,st6,st6+2);if(l==0)goto lfail;
   /*(sl1,sl2,sout1,st3)*/
 l=k_llcross(sv1,sv3,st6+1,st6+2);if(l==0)goto lfail;
 s6=st6+2;
 k_x[s6]=(k_x[st6]+k_x[st6+1])/2.0;
 k_y[s6]=(k_y[st6]+k_y[st6+1])/2.0;
 lcount=0;s=0;
 d=k_2poidist(s6,sv1,0);if(d<=k_exparad13){lcount++;ar[s]=sv1;s++;}
 d=k_2poidist(s6,sv1+1,0);if(d<=k_exparad13){lcount++;ar[s]=sv1;s++;}
 d=k_2poidist(s6,sv2,0);if(d<=k_exparad13){lcount++;ar[s]=sv2;s++;}
 d=k_2poidist(s6,sv2+1,0);if(d<=k_exparad13){lcount++;ar[s]=sv2;s++;}
 d=k_2poidist(s6,sv3,0);if(d<=k_exparad13){lcount++;ar[s]=sv3;s++;}
 d=k_2poidist(s6,sv3+1,0);if(d<=k_exparad13){lcount++;ar[s]=sv3;s++;}
 if(lcount==2)
  {l=1;k_v1=ar[0];k_v2=ar[1];
   if((k_v1==sv1&&k_v2==sv2)||(k_v1==sv2&&k_v2==sv1))k_v3=sv3;
   if((k_v1==sv2&&k_v2==sv3)||(k_v1==sv3&&k_v2==sv2))k_v3=sv1;
   if((k_v1==sv3&&k_v2==sv1)||(k_v1==sv1&&k_v2==sv3))k_v3=sv2;
   goto lend;
  }
 /*goto lfail*/

lfail:l=0;
lend:return(l);
}
/***/
long k_gettanlink(sp,sa,sc,dr,sout4,st4)
 /*ok.GetTangentialLinkFromSpToSaArc
 ->sout4,+1:TanPois,+2:NewArcMidPointIn1TanLinkCase(=:RET=1)
 ,+3:NewArcAnotherTip=OldArcTip
 RET=NumbOfPoints(0,1or2),0:NonTanPoi=Fail.  Sa must have 3point(tip1,2,mid)
 (sp=point,sa=arc,sc=centr,dr=ArcRadius,sout3,st4)
 */
short sp,sa,sc,sout4,st4;double dr;
{long l;double dd,d1,d2,d,c1,a;short s;
 d1=dr;d=k_2poidist(sp,sc,1);if(d<=k_lentol)goto lfail;
 dd=d*d-d1*d1;if(dd<=k_lentol)goto lfail;
 d2=sqrt(dd);
 c1=(d1*d1-d2*d2+d*d)/(d*2.0);
 dd=d1*d1-c1*c1;if(dd<=k_lentol)goto lfail;
 a=sqrt(dd);
 dd=c1/d;
 k_x[st4+3]=k_x[sc]+dd*(k_x[sp]-k_x[sc]);
 k_y[st4+3]=k_y[sc]+dd*(k_y[sp]-k_y[sc]);
 k_rot90(sc,st4+3,st4+2);
 if(fabs(c1)<=k_lentol)goto lfail;dd=a/c1;
 k_x[st4]=k_x[st4+3]+dd*(k_x[st4+2]-k_x[st4+3]);
 k_y[st4]=k_y[st4+3]+dd*(k_y[st4+2]-k_y[st4+3]);
 k_x[st4+1]=k_x[st4+3]-dd*(k_x[st4+2]-k_x[st4+3]);
 k_y[st4+1]=k_y[st4+3]-dd*(k_y[st4+2]-k_y[st4+3]);
 s=0;
 l=k_ifonarc(sa,st4);if(l==1){k_sendpoi(st4,sout4+s);s++;}
 l=k_ifonarc(sa,st4+1);if(l==1){k_sendpoi(st4+1,sout4+s);s++;}
 l=s;
 if(s==1){s=k_poidisttip(sa,sa+1,sp);k_sendpoi(s,sout4+3);
	  l=k_div2arcfast(s,sout4,sc,dr,sout4+2,st4);if(l==0)goto lfail;}
 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
short k_poidisttip(sp1,sp2,spb)
  /*ok.RET:distantTip sp1 or sp2 from point spb. (sp1,sp2,spb)
  Ref:poineartip()*/
short sp1,sp2,spb;
{short s;
 s=k_poineartip(sp1,sp2,spb);
 if(s==sp1)s=sp2;else s=sp1;
 return(s);
}
/***/
long k_prock(sout6,st9)
  /* ok.ProcessK(sout6,stmp9)  <-k_v1,2,3(3:MasterLink, 1,2:ToArc)
  RET1:good,0:fail
  ->sout6:ShortVecDistantTip=NewArcTip,+1:NewArcMid,+2:NewArcTipOnLongVec
   ,+3:LongVecDistantTip,+4:TanPoiOnNewArc,+5:NewArcCentr
  ->k_rr:NewArcRadius
  NeedMoreModification:AngCheck(k_v1,k_v2),SameLengthCase(k_v1,k_v2)
  !!Yet:NewArcJustMidAft gettanlink()
  */
short sout6,st9;
{long l;double d1,d2,dps,dpl,d;
 short vs,vl,ps,pl,s;/*vec,point_shorter,longer*/
 l=k_llcross(k_v3,k_v1,st9/*out*/,st9+2);if(l==0)goto lfail;
	 /*(sl1,sl2,sout1,st3)*/
 l=k_llcross(k_v3,k_v2,st9+1,st9+2);if(l==0)goto lfail;
 k_x[st9+2]=(k_x[st9]+k_x[st9+1])/2.0;
 k_y[st9+2]=(k_y[st9]+k_y[st9+1])/2.0;
 d1=k_2poidist(k_v1,k_v1+1,1);
 d2=k_2poidist(k_v2,k_v2+1,1);
 if(d1>d2){vs=k_v2;vl=k_v1;}else{vs=k_v1;vl=k_v2;}
 ps=k_poidisttip(vs,vs+1,st9+2);
 pl=k_poidisttip(vl,vl+1,st9+2);
 dps=k_2poidist(st9+2,ps,1);
 dpl=k_2poidist(st9+2,pl,1);if(dpl<k_lentol)goto lfail;
 d=dps/dpl;
 k_sendpoi(ps,sout6);k_sendpoi(st9+2,sout6+1);k_sendpoi(pl,sout6+3);
 s=sout6+1;
 k_x[sout6+2]=k_x[s]+d*(k_x[sout6+3]-k_x[s]);
 k_y[sout6+2]=k_y[s]+d*(k_y[sout6+3]-k_y[s]);

 /*gettanlink*/
 l=k_arccentor(sout6,sout6+2,sout6+1,sout6+5,st9);if(l==0)goto lfail;
   /*(k_x[]TipPoi,TipPoi,Midpoi,OutCentPoi,9TempWork) ->(double)k_rr:radius*/
 k_sendpoi(sout6,st9);k_sendpoi(sout6+2,st9+1);k_sendpoi(sout6+1,st9+2);
 l=k_gettanlink(sout6+3,st9,sout6+5,k_rr,st9+3,st9+5);if(l!=1)goto lfail;
   /*(sp=point,sa=arc,sc=centr,dr=ArcRadius,sout2,st4)*/
 k_sendpoi(st9+3,sout6+4);

 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
long k_arcarc(sa1,sa2,sc1,sc2,dr1,dr2,sout8,st16)
  /*ok.GetContinualArc(Link)Btwn2Arcs. NewLinkCase:3rdMidPoiIsk_NONARC
  RET1:good,0:fail      (sa1,sa2,sc1,sc2,dr1,dr2,sout8,st16)
  (sa1=Arc3poi(t,t,mid),sa2,sc1=cen,sc2,dr1=radius,dr2,sout8,stmp16)
  ArcsNeed3points(TipTipMid)
  ->sout8:OldSmallArcTip,+1:NewArcTipOnSmallArc,+2:NewArcMid
   ,+3:NewArcTipOnLargeArc,+4:OldLargeArcTip,+5:NewArcCentr
   ,+6:OldSmallArcMid,+7:OldLargeArcMid.
  ->k_rr:NewArcRadius
  */
short sa1,sa2,sc1,sc2,sout8,st16;double dr1,dr2;
{long l,l1,l2;short sp,s;double d;
 short as,al,cs,cl;double rs,rl;/*Arc,Centr,radius_shorter,longer*/
 if(dr1>=dr2){as=sa2;al=sa1;cs=sc2;cl=sc1;rs=dr2;rl=dr1;}
  else{as=sa1;al=sa2;cs=sc1;cl=sc2;rs=dr1;rl=dr2;}
 d=k_2poidist(cs,cl,1);if(d<=k_lentol)goto lfail;
 k_rot90(cs,cl,st16);d=rl/d;
 /*Tangential2Points*/
 k_x[st16+1]=k_x[cl]+d*(k_x[st16]-k_x[cl]);
 k_y[st16+1]=k_y[cl]+d*(k_y[st16]-k_y[cl]);
 k_x[st16+2]=k_x[cl]-d*(k_x[st16]-k_x[cl]);
 k_y[st16+2]=k_y[cl]-d*(k_y[st16]-k_y[cl]);

 sp=st16+1;/*1stTanPoi*/
 for(;;)
  {k_rot90(cl,sp,sp+2);k_sendpoi(sp,sp+3);
   l=k_arctanpoi(as,sp+2,sp,cs,rs,sp+5,sp+8);if(l==0)goto lb;
     /*(sa,stl,stp,sc,dr,sout3,st5)
       sout3:NewArcTip(OtherTip is stp),sout3+1:NewArcMid,sout3+2:NewArcCentr
      ->k_rr:NewArcRadius */
   l1=k_ifonarc(al,sp);l2=k_ifonarc(as,sp+5);/*(sa3:arc3poi,sp:point)*/
   if(l1==1&&l2==1)goto la;
  lb:sp++;/*2ndTanPoi*/if(sp>=st16+3)goto lfail;
  }
 goto lfail;

 la:k_sendpoi(sp+5,sout8+1);/*NewArcTipOnSmallArc*/
  k_sendpoi(sp+6,sout8+2);/*NewArcMid*/
  k_sendpoi(sp,sout8+3);/*NewArcTipOnLargeArc*/
  k_sendpoi(sp+7,sout8+5);/*NewArcCentr*/
 /*OldArcTips*/
 s=k_poidisttip(as,as+1,sout8+2);
 k_sendpoi(s,sout8);/*SmallArcTip*/
 s=k_poidisttip(al,al+1,sout8+2);
 k_sendpoi(s,sout8+4);/*LargeArcTip*/
 l=k_div2arcfast(sout8,sout8+1,cs,rs,sout8+6,st16);if(l==0)goto lfail;
			  /*OldSmallArcMid*/
 l=k_div2arcfast(sout8+3,sout8+4,cl,rl,sout8+7,st16);if(l==0)goto lfail;
			  /*OldLargeArcMid*/

 l=1;goto lend;
lfail:l=0;
lend:return(l);
}
/***/
