/**MachineDependentFunctions**/
#include "pktr.h"

/***EMS**/
#define EMMINT 0x67
#define PAGE_SIZE 16384
/*#define PAGE_SIZE 9*/
#define VRAM_SIZE 32000
#define Uint unsigned int

struct {
    unsigned int loadseg;
    unsigned int relocation;
} plOverlayParm;

union REGS plinreg,ploutreg;
struct SREGS plsreg;

struct EmsMappable {
    unsigned int PhysPageSeg;
    unsigned int PhysPageNo;
};
struct EmsLogToPhysMap {
    unsigned int LogPageNo;
    unsigned int PhysPageNo;
};
struct EmsLogPhysMap {
    unsigned int LogPageNo;
    unsigned int PhysPageSeg;
};
struct EmsCall {
    void far *TargetAddr;
    unsigned char NewPageMapLen;
    void  *NewPageMapPtr;
    unsigned char OldPageMapLen;
    void  *OldPageMapPtr;
    unsigned int Reserved[4];
};

struct EmsMappable plmappable[8];
struct EmsLogToPhysMap plallocmap[4];
struct EmsLogPhysMap ploldphysmap[4],plnewphysmap[4];
struct EmsCall plcalltbl;
/***************************************************************/
short plemxpg;/*usable EMS page*/
short plemson;/*1:EMSon*/
struct videoconfig vc;
typedef struct {
	int     x,y,sw;
	} MOUSE;
#define  MOUSE_VEC 0x33

    union REGS  reg;
int set_mode(void);
/********************/
plEmsOpen(int,unsigned int);

plEmsMapping(int,int,int);
plEmsClose(int);
plEmsError(int,int);
int plset_mode();
/*****************************************************************/
/****************************************************************/
plset0002()
{PLP(" \n PC9801RACRLEMSig[jgp܂(b0000Ԓn̈Ӗ)(1(yes),0(no)͂ĉD)");
 pltmds0002=(short)pltgetl((long)pltmds0002);
}
plEmsCheck()/*open handle method.  good for melemm.sys and emsdrive.sys*/
{
 unsigned int handle;
 if(_dos_open("EMMXXXX0",O_RDONLY,&handle)!=NULL)
   return(-1);
 plinreg.x.ax=0x4400;
 plinreg.x.bx=handle;
 intdos(&plinreg,&ploutreg);
 if(ploutreg.x.cflag||!(ploutreg.x.dx & 0x80))
   {_dos_close(handle);return(-1);}
 plinreg.x.ax=0x4407;
 plinreg.x.bx=handle;
 intdos(&plinreg,&ploutreg);
 _dos_close(handle);
 if(ploutreg.x.cflag||(ploutreg.h.al != 0xff))
   return(-1);
 plinreg.h.ah=0x40;
 int86(EMMINT,&plinreg,&ploutreg);
 if(ploutreg.h.ah != 0)
   return(-1);
 return(0);
}
/****/
plEmsOpen(int pagecnt,unsigned int *handl)
  /*return_value; 0:perfectly_ok, -3:decrease_page_ok, -1:bad */
{short s;s=0;
 plinreg.h.ah=0x42;
 int86(EMMINT,&plinreg,&ploutreg);
 if(ploutreg.h.ah!=0)return(-1);
 plemxpg=ploutreg.x.bx;
 if(pagecnt>ploutreg.x.bx){s=-3;pagecnt=plemxpg;}
 plinreg.h.ah=0x43;
 plinreg.x.bx=pagecnt;
 int86(EMMINT,&plinreg,&ploutreg);
 if(ploutreg.h.ah!=0)return(-1);
 *handl=ploutreg.x.dx;
 if(s==-3)return(-3);else return(0);
}
/****/
plEmsMapping(int pno,int lno,int handl)
{
 plinreg.h.ah=0x44;
 plinreg.h.al=pno;
 plinreg.x.bx=lno;
 plinreg.x.dx=handl;
 int86(EMMINT,&plinreg,&ploutreg);
 if(ploutreg.h.ah!=0)return(-1);
 return(0);
}
/****/
plEmsClose(int handl)
{
 plinreg.h.ah=0x45;
 plinreg.x.dx=handl;
 int86(EMMINT,&plinreg,&ploutreg);
 if(ploutreg.h.ah!=0)return(-1);
 return(0);
}
/****/
plEmsError(int handl,int code)
{
 printf("\n EMM.DRIVER.ERROR code= %d stat=%02x\n",code,ploutreg.h.ah);
 if(handl!=-1){plEmsClose(handl);}
 exit(-1);
}

/****************************************/
/****/
plVramb0000()/*input pltmds0002*/
{int ret;
 /*if(pltmds0002==0||plemson==0)return;!!!*/
   /* EMS.func.31 for 9801RA. B0000 bank.*/
     /*if config.sys has ems_driver,this int86 is needed;else this brings
     interupt trap error.*/
   plinreg.x.ax=0x7001;
   plinreg.h.bl=0x01;/*bank is for VRAM*/
   int86(0x67,&plinreg,&ploutreg);/*EMMINT*/
   ret=ploutreg.h.ah;/*printf(" (Ems.Func31)ret.ah=%x ",ret);*/
   if(ret!=0){printf("\n PageFrameErr(Func31)ret=%x ",ret);exit(-1);}
   return;
}
/****/
plEmsb0000()/*input pltmds0002*/
{int ret;
 /*if(pltmds0002==0||plemson==0)return;!!!*/
   /* EMS.func.31 for 9801RA. B0000 bank.*/
   plinreg.x.ax=0x7001;
   plinreg.h.bl=0x00;/*bank is for EMS*/
   int86(0x67,&plinreg,&ploutreg);/*EMMINT*/
   ret=ploutreg.h.ah;/*printf(" (Ems.Func31)ret.ah=%x ",ret);*/
   if(ret!=0){printf("\n PageFrameErr(Func31)ret=%x ",ret);exit(-1);}
   return;
}
/****/
plpre()
{short s1,ret;
 union REGS plinreg,ploutreg;

 plVramb0000();/*if(pltgraon==0)return;!!!*/
if(!plset_mode()){printf("ER.plpre=>Attention.Param.m(-1)(is 9801RA?)\n");exit(0);}
_getvideoconfig(&vc);
_clearscreen(_GCLEARSCREEN);
_remappalette(0,0x000000L);_settextcolor(0);_clearscreen(_GWINDOW);
_setlogorg(0,0);
s1=vc.numypixels;
/*without this, arrow cursor is in upper harf*/
return;
}
/****/
int plset_mode()
{
if(_setvideomode(_98RESS16COLOR))return(_98RESS16COLOR);
if(_setvideomode(_98RESS8COLOR))return(_98RESS8COLOR);else return(0);
}
/****/
plpost()
{if(pltgraon==0)return;
_remappalette(0,0x000000L);
_clearscreen(_GCLEARSCREEN);_settextcolor(7);
_getvideoconfig(&vc);
_setvideomode(_DEFAULTMODE);return;}
/***/
/***mouse****************************/
short plmouse()
{short s1,s2,s3,s4,s5,s6,s7,s8,s9,smod;long ll1,ll2;
 char c1;
 short sret;
 int fd,x=-1,y=-1;
 MOUSE m;
 FILE *fp,*fopen();
 double aaa;
 /*dpre();*/
  /*_setcolor(PCYAN);_rectangle(_GBORDER,0,0,10,10);*/
  /*_moveto(0,0);_lineto(640,400);_ellipse(_GFILLINTERIOR,0,0,640,400);*/
 mouse_on();s4=0;/*_setcolor(PMAGENTA);*/
 smod=0;/*RS_flipflop state for chattering*/
 for(;;)
   {mouse_stat(&m);
    if(smod==1&&m.sw&2){sret=0;break;}/*right sw*/
     else if(smod==1&&m.sw&1)/*left sw*/
	    {smod=0;
	     if(x!=m.x||y!=m.y)
	       {px=m.x;py=m.y;x=m.x;y=m.y;sret=1;goto la;
	       }
	     }
	     else if(smod==0&&m.sw==0)/*right,left not pushed*/
		    {smod=1;}
   }
la:mouse_off();
 /*dpost();*/
 return(sret);
}
/***/
mouse_on()
{
 reg.x.ax=1;
 int86( MOUSE_VEC , &reg , &reg );

 reg.x.ax=0x11;
 reg.x.dx=399;
 int86( MOUSE_VEC , &reg , &reg );

}
mouse_off()
{
 reg.x.ax=2;
 int86(MOUSE_VEC,&reg,&reg);
}
mouse_stat(m)
 MOUSE *m;
{
 reg.x.ax=3;
 int86(MOUSE_VEC,&reg,&reg);
 m->x=reg.x.cx;
 m->y=reg.x.dx;
 m->sw=(reg.x.bx&0xff);
}
/************************************/
